const g_reminderFoxBundle = document.getElementById("reminderFox-bundle");  

const REPEAT_LABEL_NONE =    g_reminderFoxBundle.getString("rf.add.columns.repeat.none");
const REPEAT_LABEL_YEARLY =    g_reminderFoxBundle.getString("rf.add.columns.repeat.yearly");
const REPEAT_LABEL_YEARLY_DAY =    g_reminderFoxBundle.getString("rf.add.columns.repeat.yearlyDay");
const REPEAT_LABEL_MONTHLY =    g_reminderFoxBundle.getString("rf.add.columns.repeat.monthly");
const REPEAT_LABEL_MONTHLY_DAY =    g_reminderFoxBundle.getString("rf.add.columns.repeat.monthlyDay");
const REPEAT_LABEL_WEEKLY =    g_reminderFoxBundle.getString("rf.add.columns.repeat.weekly");
const REPEAT_LABEL_WEEKLY_ALTERNATING =    g_reminderFoxBundle.getString("rf.add.columns.repeat.weekly.atlernating");
const REPEAT_LABEL_DAILY =    g_reminderFoxBundle.getString("rf.add.columns.repeat.daily");

const REMINDER_FOX_TIME_ALL_DAY_LABEL = g_reminderFoxBundle.getString("rf.add.time.allday");

const REMINDER_FOX_AM =    g_reminderFoxBundle.getString("rf.add.time.AM");
const REMINDER_FOX_PM =    g_reminderFoxBundle.getString("rf.add.time.PM");
const REMINDER_FOX_TIME_DELIMITER=g_reminderFoxBundle.getString( "rf.add.time.delimiter");


// constants 
const REMINDER_ID_REF = "idRef";

var g_modified = false;

var	selectCalendarSync = false;
var calendarReminderArray = new Array(12);

var lastSearchString = null;

var useDefaultDate = true;
var dateVariableString = "";

var REPEAT_PREVIOUS_OCCURRENCES;
var REPEAT_UPCOMING_OCCURRENCES;

var SHOW_ALL_REMINDERS = false;
var HIDE_ALL_REMINDERS = false;
var HIDE_COMPLETED_ITEMS = false;
var reminderFoxTabDirtied = false;



function selectTab() {
	// give focus to the reminder/todo description when switching tabs
	var remindersTab = document.getElementById("remindersTab");
	if ( remindersTab.selected ) {
		selectNewReminderText();
		return;
	}   
	
	
	var tabList = document.getElementById("tabList");	 
	var tabIndex =	tabList.selectedIndex;
	
	var panels = document.getElementById("tabPanelID");	
	for ( var i = 1; i < panels.childNodes.length; i++ ) {  // i =1, because we want to skip reminders
		var panel = panels.childNodes[i];
		// we want to search for the current todo tab that contains elements - then we want to move 
		// those elements to the newly selected tab
		if ( panel.hasChildNodes() ) {
			if ( tabIndex != i ) {  // only move  elements if this tab is not already populated

				// this is the active tab -  we want to move its contents to new tab				
				
				// first remove all the tree children from old tab (clear its todo list; it will be repopulated with
				// todos from new list)
				var treeChildren = document.getElementById("todoTreechildren");
				if ( treeChildren != null && treeChildren.childNodes.length > 0 ) {
					     while (treeChildren.hasChildNodes()) {
			    	 		treeChildren.removeChild(treeChildren.firstChild);
			    	 	}		
				}					
				
				// now move all elements from old tab to new tab
				var newPanel = panels.childNodes[tabIndex];
				while (panel.hasChildNodes()) {
						var child =  panel.removeChild(panel.firstChild);
						newPanel.appendChild(child);				    			
		  	 	}	

				// add new todos to the new tab's list
				fillList( false, true );
			}
			else {
				if ( reminderFoxTabDirtied ) {
					reminderFoxTabDirtied = false;
					removeAllListItems( false, true );
					fillList( false, true );
				}
			}
		}
	}
	
	var desc = document.getElementById("addTodoButton");
    desc.focus();	  
}

function reminderFox_removeListItems(listID) {
		var todoTreeChildren = document.getElementById(listID);
	     while (todoTreeChildren.hasChildNodes()) {
	    	 todoTreeChildren.removeChild(todoTreeChildren.firstChild);
	  	 }		
}

function reminderFox_enableAddTodoButton(event) {
		var newbutton= document.getElementById("newTodoButton");
		newbutton.removeAttribute( "disabled");
}
	
function loadReminders() {
	try {
		dateVariableString = reminderFox_prefs.getCharPref(REMINDER_FOX_PREF + "." + REMINDER_FOX_LIST_DATE_LABEL);
		if ( dateVariableString != REMINDER_FOX_LIST_DATE_LABEL_DEFAULT) {
			useDefaultDate = false;
		}
	} catch(e) {
		 dateVariableString = REMINDER_FOX_LIST_DATE_LABEL_DEFAULT;
	}	
	
	try {
		REPEAT_PREVIOUS_OCCURRENCES = reminderFox_prefs.getIntPref(REMINDER_FOX_PREF + "." + REMINDER_FOX_REPEAT_PREVIOUS_OCCURRENCES);
	} catch(e) {
		 REPEAT_PREVIOUS_OCCURRENCES = -1;
	}	

	try {
		REPEAT_UPCOMING_OCCURRENCES =  reminderFox_prefs.getIntPref(REMINDER_FOX_PREF + "." + REMINDER_FOX_REPEAT_UPCOMING_OCCURRENCES);
	} catch(e) {
		 REPEAT_UPCOMING_OCCURRENCES = -1;
	}		
	
	try {
		HIDE_COMPLETED_ITEMS =  reminderFox_prefs.getBoolPref(REMINDER_FOX_PREF + "." + REMINDER_FOX_HIDE_COMPLETED_ITEMS);
	} catch(e) {
		 HIDE_COMPLETED_ITEMS = false;
	}			
	var hideCompletedContextMenu = document.getElementById("treechildren-contextmenu-hideCompleted");
	var hideCompletedTodosContextMenu = document.getElementById("treechildren-contextmenu-hideCompleted2");
	if ( HIDE_COMPLETED_ITEMS ) {
		hideCompletedContextMenu.setAttribute("checked", "true");		
		hideCompletedTodosContextMenu.setAttribute("checked", "true");		
	}
	else {
		hideCompletedContextMenu.setAttribute("checked", "false");		
		hideCompletedTodosContextMenu.setAttribute("checked", "false");		
	}

	
	// create todo lists
 	var todoLists = reminderFox_getUnicodePref(REMINDER_FOX_PREF + "." + REMINDER_FOX_TODO_LISTS);
 	if ( todoLists == null ) {
 		todoLists = "";
 	}
 	
 	// check to see if we need to update the todoLists....
 	var update = false;
 	var todosArr =	reminderFox_getReminderTodos();
 	var todoListsArray = todoLists.split(",");
 	for ( var n in todosArr ) {
 		if ( n != "ToDo's" ) {
	 		var found = false;
			for ( var i = 0; i < todoListsArray.length; i++ ) {
				if ( n == todoListsArray[i]) {
					found = true;
					break;
				}
			}
			if ( !found ) {
				if ( todoLists.length > 0 ) {
					todoLists = todoLists + "," + n;
				}
				else {
					todoLists = n;
				}
				update = true;
			}
 		}
	}
	if ( update ) {
		reminderFox_setUnicodePref( REMINDER_FOX_TODO_LISTS, todoLists);		
	}
	
	
 	
	if ( todoLists != null  && todoLists.length > 0 ) {
		var todoListsArray = todoLists.split(",");
		var tabList = document.getElementById("tabList");		
		var panels = document.getElementById("tabPanelID");	
		var todosTab = document.getElementById("todosPanel");
		for ( var i = 0; i < todoListsArray.length; i++ ) { 
			var tabListItem = reminderFox_trim( todoListsArray[i] );	
			var newTabList = document.createElement("tab");
			newTabList.setAttribute( "id",   "reminderFoxList:" + tabListItem );
			newTabList.setAttribute( "label", tabListItem );
			tabList.appendChild(newTabList);
			
			var newtabpanel = todosTab.cloneNode( false );
			newtabpanel.setAttribute( "id", "reminderFoxListPanel:" + tabListItem  );
	    	panels.appendChild(newtabpanel);
		}
	}
	
	var syncedUp = reminderFox_ensureRemindersSynchronized();

	fillList(true, true);

	// select appropriate tab
	var currentTab = window.arguments[0];
	if ( currentTab == "todos" ) {
		var todosTab = document.getElementById("todosTab");
		var tabbox = document.getElementById("tabbox");
		tabbox.selectedTab = todosTab;		
	}
	
   	var todaysDate = new Date();
	oeDatePicker.onpopupshowing(todaysDate);
	selectCalendarSync = true;
	
	// show calendar based on button state
	var calendar = document.getElementById("oe-date-picker-overlay-box");
	var calendarToggleButton= document.getElementById("calendarToggle");
	if ( calendarToggleButton.checked ) {
		calendarToggleButton.setAttribute("tooltiptext", g_reminderFoxBundle.getString("rf.add.time.button.calendar.tooltip.hide"));	   
		calendar.setAttribute("hidden", "false");	
	}
	else {
		calendarToggleButton.setAttribute("tooltiptext", g_reminderFoxBundle.getString("rf.add.time.button.calendar.tooltip.show"));	   
		calendar.setAttribute("hidden", "true");	
	}

	// start synchronizing in background (if that network option is set)
	setTimeout( reminderFox_ensureRemoteRemindersSynchronizedInEditWindow, 1 );
	
	if ( window.arguments != null  && window.arguments[1] != null ) { 
		var editReminderID = window.arguments[1]. editID;
		if ( editReminderID != null ) {
			if (  window.arguments[1].isAReminder == "true" ) {
				selectReminderById(editReminderID	);
				window.setTimeout( editReminder, 1 );	
			}
			else {
				selectTodoById( window.arguments[1].todoList, editReminderID	);
				window.setTimeout( editTodo, 1 );	
			}
		}
		
	}	
}


function reminderFox_ensureRemoteRemindersSynchronizedInEditWindow() {
	// sync 'em up 
	var networkSync = REMINDER_FOX_NETWORK_SYNCHRONIZE_DEFAULT;		
	try {
		networkSync = reminderFox_prefs.getBoolPref(REMINDER_FOX_PREF + "." + REMINDER_FOX_NETWORK_SYNCHRONIZE);
	} catch(e) {
	}	
	if ( networkSync ) {
		var statusTxt = document.getElementById("reminderFox-network-status");
		statusTxt.setAttribute("value", g_reminderFoxBundle.getString("rf.add.network.status.label"));
		reminderFox_download_Startup_headless(REMINDER_FOX_UI_MODE_HEADLESS_SHOW_ERRORS,reminderFox_synchronizeEditWindowCallback );
	}	
}

function reminderFox_synchronizeEditWindowCallback( statustxtString, actionID) {
		var statusTxt = document.getElementById("reminderFox-network-status");
		
		if ( actionID == 1 ) {  // completed successfully (remote and local are equal, or were uploaded)
			statusTxt.removeAttribute("value");
		}
		else if ( actionID == 2 ) { // reminders were downloaded,  need to refresh reminders 
		
			modifiedReminders();

			reminderFox_clearRemindersAndTodos();		
			selectCalendarSync = false;
		 	// remove all of the calendar items and re-add them
			removeAllListItems( true, true);	  
			fillList(true, true);	
			selectCalendarSync = true;   
		   
		   oeDatePicker.redrawYear();
		   oeDatePicker.redrawDays();			
		   statusTxt.removeAttribute("value");
		   
			// check to see if a reminder is being edited (such as if you opened the edit window from an alarm).
			// If so, then we need to replace the old reminder instance (which is no longer in memory) with a newly
			// retrieved one from the new model in memory
		   var windowManager = Components.classes['@mozilla.org/appshell/window-mediator;1'].getService();
		   var windowManagerInterface = windowManager.QueryInterface(Components.interfaces.nsIWindowMediator);
		   var topWindow = windowManagerInterface.getMostRecentWindow("window:reminderFoxReminderOptionsDialog");
		   if (topWindow) {		 
				var staleReminder =topWindow. arguments[0].reminder;
				if ( staleReminder != null ) {
					var refreshedReminder = reminderFox_getRemindersById( staleReminder.id  );
					if  ( refreshedReminder != null ) {
						topWindow. arguments[0].reminder = refreshedReminder;
					}
				}
		   }  		   
		}
		else {
			statusTxt.setAttribute("value", statustxtString);
		}
		
}

function repopulateListForYear(oldYear, newYear) {
	selectCalendarSync = false;
 	// remove all of the calendar items and re-add them
	removeAllListItems( true, false);	  
	fillList(true, false);	
	selectCalendarSync = true;
}

function fillList(  fillReminders,  fillTodoList) {
	var i;
	if ( fillReminders ) {
		createCalendarReminderArray();
		
		var monthArray, dayReminderArray;
		var monthIndex, dayIndex, reminderIndex;
		for ( monthIndex = 0; monthIndex < 12; monthIndex++ ) {
			monthArray = calendarReminderArray[monthIndex];
			if ( monthArray != null ) {
				for ( dayIndex = 0; dayIndex < 31; dayIndex++ ) {
					dayReminderArray = monthArray[dayIndex];
					if ( dayReminderArray != null ) {
						for ( reminderIndex = 0; reminderIndex < dayReminderArray.length; reminderIndex++ ) {
							createListItemSorted(dayReminderArray[reminderIndex]);
						}
					}
				}
			}
		}

		// now that we've added the sorted reminders in the list, let's
		// select (highlight) today's reminder or the next upcoming reminder
		highlightClosestUpcomingReminder( new Date());		
	}
	
	if ( fillTodoList ) {
		var todaysDate = new Date();
		var reminderTodos = getCurrentTodoList();
		 for( i = 0; i < reminderTodos.length; i++) {
			createTodoListItem(reminderTodos[i], false, todaysDate);
		}
		highlightTodo();
	}
		
   	selectNewReminderText();
}

function doFindNext() {
	if ( lastSearchString == null ) {
		doFind();
	}
	else {
		var remindersTab = document.getElementById("remindersTab");
		if ( !remindersTab.selected ) {
			 findTodo();
		}
		else {
			 findReminder();
		}
	}
}

function doShowAll() {
	SHOW_ALL_REMINDERS = true;
	HIDE_ALL_REMINDERS = false;
	
   // redraw the year and the days
   repopulateListForYear( null , oeDatePicker.gSelectedDate.getFullYear() );
   
   oeDatePicker.redrawYear();
   oeDatePicker.redrawDays();
}

function doHideAll() {
	SHOW_ALL_REMINDERS = false;
	HIDE_ALL_REMINDERS = true;
	
   // redraw the year and the days
   repopulateListForYear( null , oeDatePicker.gSelectedDate.getFullYear() );
   
   oeDatePicker.redrawYear();
   oeDatePicker.redrawDays();
}

function toggleHideCompletedItems() {
	HIDE_COMPLETED_ITEMS = !HIDE_COMPLETED_ITEMS;
	
	var hideCompletedContextMenu = document.getElementById("treechildren-contextmenu-hideCompleted");
	var hideCompletedTodosContextMenu = document.getElementById("treechildren-contextmenu-hideCompleted2");
	if ( HIDE_COMPLETED_ITEMS ) {
		hideCompletedContextMenu.setAttribute("checked", "true");		
		hideCompletedTodosContextMenu.setAttribute("checked", "true");		
	}
	else {
		hideCompletedContextMenu.setAttribute("checked", "false");		
		hideCompletedTodosContextMenu.setAttribute("checked", "false");		
	}	
	
   // redraw the year and the days
   //repopulateListForYear( null , oeDatePicker.gSelectedDate.getFullYear() );
	selectCalendarSync = false;
 	// remove all of the calendar items and re-add them
	removeAllListItems( true, true);	  
	fillList(true, true);	
	selectCalendarSync = true;   
   
   oeDatePicker.redrawYear();
   oeDatePicker.redrawDays();
}


function doFind() {
	var nsIPromptService = Components.interfaces.nsIPromptService;
	var nsPrompt_CONTRACTID = "@mozilla.org/embedcomp/prompt-service;1";
	var gPromptService = Components.classes[nsPrompt_CONTRACTID].getService(nsIPromptService);
	var result = { value: lastSearchString };
	var dummy = { value: 0 };
	var title;
	var remindersTab = document.getElementById("remindersTab");
	if ( !remindersTab.selected ) {
		 title =  g_reminderFoxBundle.getString("rf.add.find.todo.title");
	}
	else {
		 title =  g_reminderFoxBundle.getString("rf.add.find.title");
	}
	
	if (gPromptService.prompt(window,
                            title,
                            g_reminderFoxBundle.getString("rf.add.find.description"),
                            result,
                            null,
                            dummy)) {
                            
            lastSearchString = result.value;
          
			// only bring up find dialog if reminders tab is selected
			var remindersTab = document.getElementById("remindersTab");
			if ( remindersTab.selected ) {
				findReminder();             ;
			}
			else {
				findTodo();
			}          
        	
    }    
}

function findReminder( ) {
	var i;
	var item;
	var row;
	var descCell;
	var descCellLabel;
	
	var selectedTreeItemIndex = document.getElementById("reminderTree").currentIndex;
	// if nothing selected, default to start of list
	if ( selectedTreeItemIndex == -1 ) {
		selectedTreeItemIndex = 0;
	}
		
	var treeChildren = document.getElementById("treechildren");
	var selectedTreeItem = treeChildren.childNodes[selectedTreeItemIndex];

	var dateLabel = selectedTreeItem.childNodes[0].childNodes[0].getAttribute("label");
	var descLabel = selectedTreeItem.childNodes[0].childNodes[1].getAttribute("label");
   caseInsensitiveLastSearchString = lastSearchString.toUpperCase();

	var treeitems = treeChildren.childNodes;
	var startIndex = selectedTreeItemIndex;
	if ( startIndex + 1 < treeitems.length ) {
		startIndex = startIndex + 1;
	}
	else { 
		startIndex = 0;
	}

	var foundIndex = -1;
	for ( i=startIndex; i < treeitems.length; i++) {
		item = treeitems[i];
		row = item.childNodes[0];
		descCell = row.childNodes[1];
		descCellLabel = descCell.getAttribute("label");
		descCellLabel = descCellLabel.toUpperCase();

		if ( descCellLabel.indexOf( caseInsensitiveLastSearchString ) != -1  ) {
			foundIndex = i;

			break;
		}
	}
	
	if ( foundIndex == -1 ) {
		for ( i=0; i < startIndex; i++) {
			item = treeitems[i];
			 row = item.childNodes[0];
			descCell = row.childNodes[1];
			descCellLabel = descCell.getAttribute("label");
			descCellLabel = descCellLabel.toUpperCase();

			if ( descCellLabel.indexOf( caseInsensitiveLastSearchString ) != -1  ) {
				foundIndex = i;
				break;
			}
		}
	}
	
	// if we found a search match, then highlight the new reminder in the list
	if ( foundIndex != -1 ) {		
		var treeSelection = document.getElementById("reminderTree").view.selection		
		treeSelection.select(foundIndex);
		
		// make sure that newly selected row is shown in scroll pane
		var value = document.getElementById("treeparent").value;
	  	var tree = document.getElementById("reminderTree");			
		var boxobject = tree.boxObject;
		boxobject.QueryInterface(Components.interfaces.nsITreeBoxObject);
		
		// make sure it shows up at the top if possible
		var first = boxobject.getFirstVisibleRow();
		var last = boxobject.getLastVisibleRow();
		if ( foundIndex < first || foundIndex > last ) {				
			boxobject.scrollToRow(treeitems.length - 9);
		}
		
		var previousReminderOffset = 3;
		if ( foundIndex < previousReminderOffset ) { 
			boxobject.ensureRowIsVisible(i);
		}
		else {
			boxobject.ensureRowIsVisible(foundIndex  - previousReminderOffset);
		}
	}
}


function findTodo( ) {
	var i;
	var item;
	var row;
	var descCell;
	var descCellLabel;
	
	var selectedTreeItemIndex = document.getElementById("todoTree").currentIndex;
	// if nothing selected, default to start of list
	if ( selectedTreeItemIndex == -1 ) {
		selectedTreeItemIndex = 0;
	}
		
	var treeChildren = document.getElementById("todoTreechildren");
	var selectedTreeItem = treeChildren.childNodes[selectedTreeItemIndex];

	var descLabel = selectedTreeItem.childNodes[0].childNodes[1].getAttribute("label"); // 1 is description for Todos
   caseInsensitiveLastSearchString = lastSearchString.toUpperCase();

	var treeitems = treeChildren.childNodes;
	var startIndex = selectedTreeItemIndex;
	if ( startIndex + 1 < treeitems.length ) {
		startIndex = startIndex + 1;
	}
	else { 
		startIndex = 0;
	}

	var foundIndex = -1;
	for ( i=startIndex; i < treeitems.length; i++) {
		item = treeitems[i];
		row = item.childNodes[0];
		descCell = row.childNodes[1]; // 1 is description for todo's
		descCellLabel = descCell.getAttribute("label");
		descCellLabel = descCellLabel.toUpperCase();
		if ( descCellLabel.indexOf( caseInsensitiveLastSearchString ) != -1  ) {
			foundIndex = i;

			break;
		}
	}
	
	if ( foundIndex == -1 ) {
		for ( i=0; i < startIndex; i++) {
			item = treeitems[i];
			 row = item.childNodes[0];
			descCell = row.childNodes[1]; // 1 is description for ToDo's
			descCellLabel = descCell.getAttribute("label");
			descCellLabel = descCellLabel.toUpperCase();

			if ( descCellLabel.indexOf( caseInsensitiveLastSearchString ) != -1  ) {
				foundIndex = i;
				break;
			}
		}
	}
	
	// if we found a search match, then highlight the new reminder in the list
	if ( foundIndex != -1 ) {		
		var treeSelection = document.getElementById("todoTree").view.selection		
		treeSelection.select(foundIndex);
		
		// make sure that newly selected row is shown in scroll pane
		var value = document.getElementById("treeparent").value;
	  	var tree = document.getElementById("todoTree");			
		var boxobject = tree.boxObject;
		boxobject.QueryInterface(Components.interfaces.nsITreeBoxObject);
		
		// make sure it shows up at the top if possible
		var first = boxobject.getFirstVisibleRow();
		var last = boxobject.getLastVisibleRow();
		if ( foundIndex < first || foundIndex > last ) {				
			boxobject.scrollToRow(treeitems.length - 9);
		}
		
		var previousReminderOffset = 3;
		if ( foundIndex < previousReminderOffset ) { 
			boxobject.ensureRowIsVisible(i);
		}
		else {
			boxobject.ensureRowIsVisible(foundIndex  - previousReminderOffset);
		}
	}
}

function selectNewReminderText() {
   var desc = document.getElementById("addReminderButton");  
    desc.focus();
}



function toggleCalendar() {
	var calendar = document.getElementById("oe-date-picker-overlay-box");
	var calendarToggleButton= document.getElementById("calendarToggle");
	if ( calendarToggleButton.checked ) {
		calendar.setAttribute("hidden", "true");	
		calendarToggleButton.setAttribute("tooltiptext", g_reminderFoxBundle.getString("rf.add.time.button.calendar.tooltip.show"));	
	}
	else {
		calendar.setAttribute("hidden", "false");	
		calendarToggleButton.setAttribute("tooltiptext", g_reminderFoxBundle.getString("rf.add.time.button.calendar.tooltip.hide"));	
	}
}

function reminderSelected(event) {
	if ( selectCalendarSync ) {
		var selectedTreeItemIndex = document.getElementById("reminderTree").currentIndex;
		if ( selectedTreeItemIndex >= 0 ) {
			var treeChildren = document.getElementById("treechildren");
			if ( treeChildren != null ) {
				if ( selectedTreeItemIndex >= treeChildren.childNodes.length ) {
					selectedTreeItemIndex = treeChildren.childNodes.length - 1;
				} 
				var selectedTreeItem = treeChildren.childNodes[selectedTreeItemIndex];
				
				var monthAsInteger;
				var day;
				var dateLabel = selectedTreeItem.childNodes[0].childNodes[0].getAttribute("label");				
				if ( useDefaultDate ) {
					var dateLabelArray = dateLabel.split(" ");
					monthAsInteger = reminderFox_getMonthAsInteger(dateLabelArray[0]);		
					day = dateLabelArray[1];
				}
				else {
					var monthAndDate = reminderFox_decodeDateVariableString(dateVariableString, dateLabel );
					day = monthAndDate.date;
					monthAsInteger = monthAndDate.month;							
				}
				

				var year = oeDatePicker.gSelectedDate.getFullYear();
				if ( year == null ) {
					year = new Date().getFullYear();
				}
				var newDate = new Date(year, monthAsInteger, day );	
				oeDatePicker.onpopupshowing(newDate);
			}
		}
	}
}


function reminderFox_getReminderViewAsHTMLFile() {
	var file;
	var savefilePath;
	// check if user has specified a specific file path in their preferences
	try {
		savefilePath = reminderFox_prefs.getCharPref(REMINDER_FOX_PREF + "." + REMINDER_FOX_STORE_FILE);
	}
	catch ( e) {
	}
	// if not, then use default location in profile
	if ( savefilePath == null || savefilePath == "" ) {
		 file = Components.classes["@mozilla.org/file/directory_service;1"]
       		  .getService(Components.interfaces.nsIProperties)
    	      .get("ProfD", Components.interfaces.nsIFile);

	      file.append( "reminderfox" );
	      file.append( "reminderfox.ics" + ".html" );			
	}
	else {
		savefilePath = savefilePath + ".html";
		file = Components.classes["@mozilla.org/file/local;1"]
					.createInstance(Components.interfaces.nsILocalFile);
		file.initWithPath( savefilePath );
	}
	return file;
}


function reminderFox_writeOutReminderViewAsHTMLFile( file, outputStr )  {
	// now write file out to filesystem
	
 
	try {
		netscape.security.PrivilegeManager.enablePrivilege("UniversalXPConnect");
	} catch (e) {
		alert("Permission to save file was denied.");
	}

	if ( file.exists() == false ) {
		file.create( Components.interfaces.nsIFile.NORMAL_FILE_TYPE, 420 );
	}	
	
	var outputStream = Components.classes["@mozilla.org/network/file-output-stream;1"]
		.createInstance( Components.interfaces.nsIFileOutputStream );
	outputStream.init( file, 0x04 | 0x08 | 0x20, 420, 0 );
	
	var converter = Components.classes["@mozilla.org/intl/scriptableunicodeconverter"]
	                          .createInstance(Components.interfaces.nsIScriptableUnicodeConverter);
	converter.charset = "UTF-8";
	
	var chunk = null;
	try {
		chunk = converter.ConvertFromUnicode(outputStr);
	}
	catch( e ) {
		chunk = outputStr;
	}
	outputStream.write(chunk, chunk.length);	
	
	 var fin = converter.Finish();
	 if (fin.length > 0)
	   outputStream.write(fin, fin.length);
	 outputStream.close();	
	
}


function doShowHTML() {
	var outputStr = "";
	outputStr += "<basefont  color=\"#FFFFFF\">\n";
	
	outputStr += "<!DOCTYPE HTML PUBLIC \"-//W3C//DTD HTML 4.01 // Transitional//EN\">\n";
	outputStr += "<HTML>\n";
	
	outputStr += "<HEAD>\n";
	outputStr += "<TITLE>" + g_reminderFoxBundle.getString("rf.title") + "</TITLE>\n";
	//outputStr += "<link rel=\"shortcut icon\" href=\"" + REMINDER_FOX_REMIND_UNTIL_COMPLETED_IMAGE + "\" type=\"image/png\" >\n";
	outputStr += "</HEAD>\n";
	outputStr += "<BODY>\n";
	
	outputStr += "<TABLE border=\"1\">\n";
	outputStr += "<TBODY>\n";	
	outputStr += "  <TR>\n";
	
	outputStr += "    <TD>\n";
	outputStr += "      <b>" + g_reminderFoxBundle.getString("rf.html.heading.date") + "</b>\n";
	outputStr += "    </TD>\n";
	
	outputStr += "    <TD>\n";
	outputStr += "      <b>" + g_reminderFoxBundle.getString("rf.html.heading.reminder") + "</b>\n";
	outputStr += "    </TD>\n";
	
	outputStr +=  "    <TD>\n";
	outputStr += "      <b>" + g_reminderFoxBundle.getString("rf.html.heading.time") + "</b>\n";
	outputStr += "    </TD>\n";	
	
	outputStr += "  </TR>\n";		

	var i;
	var item;
	var row;
	var dateCell;
	var dateCellLabel	
	var descCell;
	var descCellLabel;
	var timeCell;
	var timeCellLabel;	
		
	var treeChildren = document.getElementById("treechildren");
	var treeitems = treeChildren.childNodes;

	for ( i=0; i < treeitems.length; i++) {
		item = treeitems[i];
		row = item.childNodes[0];
		dateCell = row.childNodes[0];
		dateCellLabel = dateCell.getAttribute("label");		
		dateCellLabel = dateCellLabel.replace(new RegExp(/ /g),"&nbsp;");  
		descCell = row.childNodes[1];
		descCellLabel = descCell.getAttribute("label");
		timeCell = row.childNodes[2];
		timeCellLabel = timeCell.getAttribute("label");		
		timeCellLabel = timeCellLabel.replace(new RegExp(/ /g),"&nbsp;");  
		
		var important = descCell.getAttribute("properties" ) == "important" ||
			descCell.getAttribute( "properties" ) == "imporantCompleteText";
		var completed = descCell.getAttribute("properties" ) == "completeText" ||
			descCell.getAttribute( "properties" ) == "imporantCompleteText";			
					
		outputStr +=  "  <TR>\n";

		outputStr +=  "    <TD>\n";
		if ( important ) {
			outputStr +=  "    <FONT color=\"FF0000\">\n";
		}	
		if ( completed ) {
			outputStr +=  "    <del>\n";
		}
		outputStr +=  "      " ;
		outputStr += dateCellLabel + "\n";
		if ( important ) {
			outputStr +=  "    </FONT>\n";
		}	
		if ( completed ) {
			outputStr +=  "    </del>\n";
		}
		outputStr +=  "    </TD>\n";
		
		outputStr +=  "    <TD>\n";
		if ( important ) {
			outputStr +=  "    <FONT color=\"FF0000\">\n";
		}	
		if ( completed ) {
			outputStr +=  "    <del>\n";
		}		
		outputStr +=  "      " ;
		outputStr +=  descCellLabel + '\n';
		if ( important ) {
			outputStr +=  "    </FONT>\n";
		}			
		if ( completed ) {
			outputStr +=  "    </del>\n";
		}
		outputStr +=  "    </TD>\n";		
		
		outputStr +=  "    <TD>\n";
		if ( important ) {
			outputStr +=  "    <FONT color=\"FF0000\">\n";
		}	
		if ( completed ) {
			outputStr +=  "    <del>\n";
		}		
		outputStr +=  "      " ;
		outputStr +=  timeCellLabel + '\n';
		if (important ) {
			outputStr +=  "    </FONT>\n";
		}		
		if ( completed ) {
			outputStr +=  "    </del>\n";
		}
		outputStr +=  "    </TD>\n";				

		
		outputStr +=  "  </TR>\n";	

		// output notes if available
		// want to replace in notes: ("\n", "<BR/>") to get line breaks
		var reminder =  reminderFox_getRemindersById( row.getAttribute(REMINDER_ID_REF) );
	 	if ( reminder != null  && reminder.notes != null ) { 		
			outputStr +=  "  <TR>\n";
			
			outputStr +=  "    <TD>\n";
			outputStr +=  "    </TD>\n";
			
			outputStr +=  "    <TD>\n";
			var notes = reminder.notes;
			dump( "\nNOTES: " + notes + "\n");
			notes = notes.replace(new RegExp(/\n/g),"<BR/>");  	
			dump( "modded NOTES: " + notes + "\n");
			outputStr +=  "      " + notes;
			
			outputStr +=  "    </TD>\n";		
			
			outputStr +=  "    <TD>\n";
			outputStr +=  "    </TD>\n";
			
			outputStr +=  "    <TD>\n";
			outputStr +=  "    </TD>\n";			
			
			outputStr +=  "  </TR>\n";	
	 	}		
		
	}	
	
	outputStr +=  " </TBODY>\n";
	outputStr +=  "</TABLE>\n";
	outputStr +=  "</BODY>\n";
	outputStr +=  "</HTML>\n";
	
	var file = reminderFox_getReminderViewAsHTMLFile();
	reminderFox_writeOutReminderViewAsHTMLFile(file, outputStr);
	var tempURL = "file:///" + file.path; 
	reminderFox_openURL(tempURL );
	//file.remove(false);  // can't remove here as it can be removed before the browser opens (in Thunderbird case)
}

function doShowToDosHTML() {
	var outputStr = "";
	
	// get list name for title
	var tabList = document.getElementById("tabList");	
	var tab =	tabList.selectedItem;
	var listName = tab.getAttribute( "label");

	outputStr += "<basefont  color=\"#FFFFFF\">\n";		
	outputStr += "<!DOCTYPE HTML PUBLIC \"-//W3C//DTD HTML 4.01 // Transitional//EN\">\n";

	outputStr += "<HTML>\n";
	outputStr += "<HEAD>\n";
	outputStr += "<TITLE>" +g_reminderFoxBundle.getString("rf.title") + " - " + listName + "</TITLE>\n";
	outputStr += "</HEAD>\n";
	outputStr += "<BODY>\n";
	outputStr += "<TABLE border=\"1\">\n";
	outputStr += " <TBODY>\n";	
	
	outputStr +=  "  <TR>\n";
	
	outputStr +=  "    <TD>\n";		
	outputStr +=  "      <b>" + g_reminderFoxBundle.getString("rf.html.heading.todo.number") + "</b>\n";
	outputStr +=  "    </TD>\n";
	
	outputStr +=  "    <TD>\n";	
	outputStr +=  "      <b>" + listName + "</b>\n";
	outputStr +=  "    </TD>\n";
	
	outputStr +=  "    <TD>\n";
	outputStr +=  "      <b>" + g_reminderFoxBundle.getString("rf.html.heading.date") + "</b>\n";
	outputStr +=  "    </TD>\n";	
	
	outputStr +=  "    <TD>\n";
	outputStr +=  "      <b>" + g_reminderFoxBundle.getString("rf.html.heading.time") + "</b>\n";
	outputStr +=  "    </TD>\n";		
	
	outputStr +=  "  </TR>\n";		

	var i;
	var item;
	var row;
	var dateCell;
	var dateCellLabel	
	var descCell;
	var descCellLabel;
	var timeCell;
	var timeCellLabel;	
		
	var treeChildren = document.getElementById("todoTreechildren");
	var treeitems = treeChildren.childNodes;

	for ( i=0; i < treeitems.length; i++) {
		item = treeitems[i];
		row = item.childNodes[0];
		dateCell = row.childNodes[0];
		dateCellLabel = dateCell.getAttribute("label");
		dateCellLabel = dateCellLabel.replace(new RegExp(/ /g),"&nbsp;");  
		descCell = row.childNodes[1];
		descCellLabel = descCell.getAttribute("label");
		timeCell = row.childNodes[2];
		timeCellLabel = timeCell.getAttribute("label");		
		timeCellLabel = timeCellLabel.replace(new RegExp(/ /g),"&nbsp;");  
		
		var important = descCell.getAttribute("properties" ) == "important" ||
			descCell.getAttribute( "properties" ) == "imporantCompleteText";
		var completed = descCell.getAttribute("properties" ) == "completeText" ||
			descCell.getAttribute( "properties" ) == "imporantCompleteText";						
		
		outputStr +=  "  <TR>\n";
		
		outputStr +=  "    <TD>\n";
		if ( important ) {
			outputStr +=  "    <FONT color=\"FF0000\">\n";
		}			
		if ( completed ) {
			outputStr +=  "    <del>\n";
		}		
		outputStr +=  "      ";		
		outputStr += (i+1) + "\n";  // +1 so we start with a 1-based index
		if ( important ) {
			outputStr +=  "    </FONT>\n";
		}		
		if ( completed ) {
			outputStr +=  "    </del>\n";
		}
		outputStr +=  "    </TD>\n";
		
		outputStr +=  "    <TD>\n";
		if ( important)  {
			outputStr +=  "    <FONT color=\"FF0000\">\n";
		}			
		if ( completed ) {
			outputStr +=  "    <del>\n";
		}		
		outputStr +=  "      " ;
		outputStr +=  descCellLabel + '\n';
		if ( important ) {
			outputStr +=  "    </FONT>\n";
		}			
		if ( completed ) {
			outputStr +=  "    </del>\n";
		}		
		outputStr +=  "    </TD>\n";		
		
		outputStr +=  "    <TD>\n";
		if ( important ) {
			outputStr +=  "    <FONT color=\"FF0000\">\n";
		}	
		if ( completed ) {
			outputStr +=  "    <del>\n";
		}		
		outputStr +=  "      " ;
		if ( dateCellLabel == "" ) {
			dateCellLabel = "&nbsp;";
		}
		outputStr += dateCellLabel + "\n";
		if ( important ) {
			outputStr +=  "    </FONT>\n";
		}				
		if ( completed ) {
			outputStr +=  "    </del>\n";
		}		
		outputStr +=  "    </TD>\n";		
		
		outputStr +=  "    <TD>\n";
		if ( important ) {
			outputStr +=  "    <FONT color=\"FF0000\">\n";
		}	
		if ( completed ) {
			outputStr +=  "    <del>\n";
		}		
		outputStr +=  "      " ;
		if ( timeCellLabel == "" ) {
			timeCellLabel = "&nbsp;";
		}		
		outputStr +=  timeCellLabel + '\n';
		if (important ) {
			outputStr +=  "    </FONT>\n";
		}		
		if ( completed ) {
			outputStr +=  "    </del>\n";
		}				
		outputStr +=  "    </TD>\n";				
		
		outputStr +=  "  </TR>\n";	
		
		// output notes if available
		// want to replace in notes: ("\n", "<BR/>") to get line breaks
		var todo = reminderFox_getTodosById( row.getAttribute(REMINDER_ID_REF),  getCurrentTodoList() );					
	 	if ( todo != null  && todo.notes != null ) { 		
			outputStr +=  "  <TR>\n";
			
			outputStr +=  "    <TD>\n";
			outputStr +=  "    </TD>\n";
			
			outputStr +=  "    <TD>\n";

			var notes = todo.notes;
			notes = notes.replace(new RegExp(/\n/g),"<BR/>");  					
			outputStr +=  "      " +notes;
			
			outputStr +=  "    </TD>\n";		
			
			outputStr +=  "    <TD>\n";
			outputStr +=  "    </TD>\n";
			
			outputStr +=  "    <TD>\n";
			outputStr +=  "    </TD>\n";			
			
			outputStr +=  "  </TR>\n";	
	 	}
		
	}	

	outputStr +=  " </TBODY>\n";
	outputStr +=  "</TABLE>\n";
	outputStr +=  "</BODY>\n";
	outputStr +=  "</HTML>\n";
	
	var file = reminderFox_getReminderViewAsHTMLFile();
	reminderFox_writeOutReminderViewAsHTMLFile(file, outputStr);
	var tempURL = "file:///" + file.path; 
	reminderFox_openURL(tempURL );	
	//file.remove(false);  // can't remove here as it can be removed before the browser opens (in Thunderbird case)
}


function createCalendarReminderArray() {
	var monthArray;
	var monthDay;	
	var dayReminderArray;	
	var newDayReminder;
	var  length;
	var val;
		
	calendarReminderArray = new Array(12); 
	
	var reminders = reminderFox_getReminderEvents();	
	var currentDate = oeDatePicker.gSelectedDate;
	if ( currentDate == null ) {
		currentDate = new Date();
	}
	var	year = currentDate.getFullYear();

	var currentDate = new Date( year, 0, 1 );  // start of year
	var endDate  = new Date( year, 11, 31 );  // end of year	
	var startDate;
	var todaysDate = new Date();
	for( var i = 0; i < reminders.length; i++) {
		var basereminder = reminders[i];
		startDate = currentDate;
		var allReminders = reminderFox_getAllRemindersInDateRange( basereminder,  startDate, endDate, false );
		var x;
		// maybe make this a method that returns start/endindex
		var startIndex = 0;
		var endIndex = 0;
		if ( allReminders.length > 0 ) {
			endIndex  = allReminders.length;
		}
		if ( allReminders.length > 0) {
			if ( SHOW_ALL_REMINDERS ) {
				startIndex = 0;
				endIndex = allReminders.length;
			}
			else if ( HIDE_ALL_REMINDERS ) {
				for ( x = 0; x < allReminders.length; x++ ) {
					if ( reminderFox_compareDates( allReminders[x].date, todaysDate) != -1 ) {
						break;
					}
				}
				// handle end case where x = length
				startIndex = x;
		
				// need to show reminders of yearly that have passed
				if ( startIndex == allReminders.length ) {				
					startIndex = allReminders.length -1;
				}
				endIndex = startIndex + 1;  
				if ( endIndex > allReminders.length )  {
					endIndex = allReminders.length;
				}
			}
			// if there's only 1 reminder and the prefs are set to show prev/next, then just ignore the check
			else if ( !(allReminders.length == 1 && REPEAT_PREVIOUS_OCCURRENCES >= 1 &&  REPEAT_UPCOMING_OCCURRENCES >=1 ) )  {			
				for ( x = 0; x < allReminders.length; x++ ) {
					if ( reminderFox_compareDates( allReminders[x].date, todaysDate) != -1 ) {
						break;
					}
				}
				
				if ( REPEAT_PREVIOUS_OCCURRENCES == -1 ) { 
					startIndex = 0;
				}
				else {
					startIndex = x - REPEAT_PREVIOUS_OCCURRENCES;
					if ( startIndex < 0 ) {
						startIndex = 0;
					}
				}
				
				if ( REPEAT_UPCOMING_OCCURRENCES == -1 ) {
					endIndex = allReminders.length;
				}
				else {
					endIndex = x + REPEAT_UPCOMING_OCCURRENCES;
					if ( endIndex > allReminders.length ) {
						endIndex = allReminders.length;
					}
				}
				
				// if the user is showing no previous occurrences, we still want to show if a previous reminder is marked as RUC
				if ( REPEAT_PREVIOUS_OCCURRENCES == 0 && 
					basereminder.remindUntilCompleted == REMINDERFOX_REMIND_UNTIL_COMPLETE_MARKED ) {
					if ( startIndex > 0  && startIndex == endIndex  ) { // eminderFox_compareDates( allReminders[x].date, todaysDate) == 1 ) {
						startIndex = startIndex - 1;														
					}					
				}								
			 }
		}
       for (  var j = startIndex; j < endIndex; j++ ) {		
			var reminder = allReminders[j];		
			reminder = reminderFox_processReminderDescription(reminder, currentDate.getFullYear());	
			// if it's marked as RemindUntilComplete, this should be treated as Today's date			
		 	if ( reminder.remindUntilCompleted == REMINDERFOX_REMIND_UNTIL_COMPLETE_MARKED && j == startIndex ) {
		 		var todaysDate = new Date();
		 		if (  todaysDate.getFullYear() == year ) {   // only valid for current year in the calendar
		 			reminder = reminderFox_cloneReminderFoxEvent(reminder);		 	
					reminder.date  = new Date( todaysDate.getFullYear(), todaysDate.getMonth(), todaysDate.getDate(), 
					 			reminder.date.getHours(), reminder.date.getMinutes() );		
				}		 								
		 	}		 	
	
			monthArray = calendarReminderArray[reminder.date.getMonth()];
			if ( monthArray == null ) {
				monthArray = new Array(31);
				calendarReminderArray[reminder.date.getMonth()] = monthArray;
			}
				
			monthDay = reminder.date.getDate();
			dayReminderArray = monthArray[monthDay - 1];
			if ( dayReminderArray == null ) {
				dayReminderArray = new Array();
				monthArray[monthDay - 1] = dayReminderArray;
			}
			length = dayReminderArray.length;
			
			var ignoreReminder = false;
			if (HIDE_COMPLETED_ITEMS &&
				 reminderFox_isCompletedForDate( reminder, reminder.date) )  {
				ignoreReminder = true;				
			}
			if ( !ignoreReminder ) {
				dayReminderArray[length] = reminder;
			}
		}
	}
}


function reminderFox_getAddTimeString( reminder ) {
	var timeString = null;
	if ( !reminder.allDayEvent ) {
		try {
			var hours = reminder.date.getHours();
			
			var AMorPM = REMINDER_FOX_PM;				
			var use24HourTime;
			try {
				use24HourTime = reminderFox_prefs.getBoolPref(REMINDER_FOX_PREF + "." + REMINDER_FOX_USE_24_HOUR_TIME);
			} catch(e) {
			}				
			if (  use24HourTime ) {
				AMorPM = "";
				if ( hours < 10 ) {
					hours = "0" + hours;
				}
		
			}		
		
			if ( AMorPM != "" ) {
				if ( hours < 12 ) {
					AMorPM = REMINDER_FOX_AM;
				}
				if ( hours == 0 ) {
					hours = 12;
				}
				if ( hours >= 13 ) {
					hours = hours -12;
				}	
			}			

			var minutes = reminder.date.getMinutes();
			if ( minutes < 10 ) {
				minutes = "0" + minutes;
			}
							
			timeString = hours + REMINDER_FOX_TIME_DELIMITER + minutes;
			if ( AMorPM != "" ) {
				timeString = timeString + " " + AMorPM;		
			}
		}
		catch ( e ) { 
		}
	}	
	return timeString;
}

function setRemindUntilCompleteColumn( reminder, columnLabel ) {
         if ( reminder.remindUntilCompleted == REMINDERFOX_REMIND_UNTIL_COMPLETE_TO_BE_MARKED ) {
         	 columnLabel.setAttribute("src",REMINDER_FOX_REMIND_UNTIL_COMPLETED_TO_BE_MARKED_IMAGE);	
         }
         else  if ( reminder.remindUntilCompleted == REMINDERFOX_REMIND_UNTIL_COMPLETE_MARKED ) {
         	 columnLabel.setAttribute("src",REMINDER_FOX_REMIND_UNTIL_COMPLETED_IMAGE);
         }
}




function getTimeHoursFromString(time) {
	var hours = 0;
	var startindex = time.indexOf(g_reminderFoxBundle.getString("rf.add.time.delimiter") ); 
	if ( startindex != -1 ) {
		try {
			var hours = parseInt(time.substring(0, startindex ));
			var minutes =  time.substring(startindex+1, startindex + 3);
			// now trim remainder
			var remainder = time.substring( startindex + 3, time.length );
			if ( remainder != "" ) {
				remainder = reminderFox_trim( remainder );
				var AMorPM = remainder;
				if ( AMorPM.toUpperCase() == REMINDER_FOX_PM.toUpperCase() ) {
					if ( hours != 12 ) {
						hours = hours+12;
					}
				}
				else { 
					if ( hours == 12 ) {
						hours = 0;
					}
				}
			}
		}
		catch ( e ) {
		}
	}
	return hours;
}

function getTimeMinutesFromString(time) {
	var minutes = 0;
	var startindex = time.indexOf(g_reminderFoxBundle.getString("rf.add.time.delimiter") ); 
	if ( startindex != -1 ) {
		try {
			 minutes =  time.substring(startindex+1, startindex + 3);
		}
		catch ( e ) {
		}
	}
	return minutes;
}

// Thu, 2005/31/02  ==> [dayOfWeek], [year]/[date]/[numMonth]   
function reminderFox_decodeDateVariableString(variableString, dateString )  {		
	var month;
	var date;
	var currentIndex = 0;
	var lastVarIndex = 0;
	var substr;

	var startBracketIndex =variableString.indexOf("[");
	
	// if there's text before the first variable, skip it
	if ( startBracketIndex != 0 ) {
		substr = variableString.substring( 0, endBracketIndex);			
		var currentStartIndex = dateString.indexOf( substr, currentIndex);
		if ( currentStartIndex != -1 ) {
			currentIndex = currentStartIndex + substr.length;
		}
	}

	while (startBracketIndex != -1 ) {
		var endBracketIndex = variableString.indexOf("]", startBracketIndex);
		if (endBracketIndex != -1) {		
			var variable = variableString.substring(startBracketIndex + 1, endBracketIndex);		
			var resolvedVar;
			// find start of next variable
			var nextStartingBracketIndex = variableString.indexOf( '[', (endBracketIndex + 1));
			var substr2;
			if ( nextStartingBracketIndex == -1 ) {
				substr2 = variableString.substring( endBracketIndex +1, variableString.length);		
			}
			else {
				substr2 = variableString.substring( endBracketIndex +1, nextStartingBracketIndex);
			}
			if ( substr2 == "" ) {
				resolvedVar = dateString.substr( currentIndex, dateString.length);
				currentIndex = -1;
			}
			else {				
				var curIndexAfterVariable = dateString.indexOf( substr2, currentIndex);
				resolvedVar = dateString.substring( currentIndex, curIndexAfterVariable);
				currentIndex = curIndexAfterVariable + substr2.length;
			}	
			startBracketIndex = nextStartingBracketIndex;						
			if ( variable == "date" ) {
				// remove leading 0
				date = resolvedVar;
				if ( date.length == 2 && date.charAt(0) == '0' ) {
					date = date.substring( 1, 2);
				}
			}
			else if ( variable == "numMonth") {
				month =resolvedVar;
				if ( month.length == 2 && month.charAt(0) == '0' ) {
					month = month.substring( 1, 2);
				}
				month = parseInt(month) - 1;  // account for visible date using 1-based index
			}
			else if ( variable == "longMonth") {
				month = reminderFox_getMonthAsInteger( resolvedVar );
			}
			else if ( variable == "shortMonth") {
				month =reminderFox_getShortMonthAsInteger( resolvedVar);
			}
			if ( date != null && month != null ) {
				// we found both the month and date; let's return them
				break;
			}
		}
		else {
			break;
		}
	}
	
	return {   month: month, date: date};
}

function reminderFox_getDateVariableString(reminder, date )  {
	return reminderFox_getDateVariable( reminder, date, dateVariableString );
}




function createListItem(baseReminder) {
	var lastListIndex = 0;
	var once = document.getElementById("occurrence");
	var treeChildren = document.getElementById("treechildren");
	var year;
	if ( oeDatePicker.gSelectedDate != null ) {
		year = oeDatePicker.gSelectedDate.getFullYear();
	}
	if ( year == null ) {
		year = new Date().getFullYear();
	}	 
	var currentDate = new Date( year, 0, 1 );  // start of year
	var endDate  = new Date( year, 11, 31 );  // end of year
	var todaysDate = new Date();
	var allReminders = reminderFox_getAllRemindersInDateRange( baseReminder,  currentDate, endDate, false );
	
	var startIndex = 0;
	var endIndex = 0;
	if ( allReminders.length > 0 ) {
		endIndex  = allReminders.length;
	}
	if ( allReminders.length > 0) {
		if ( SHOW_ALL_REMINDERS ) {
			startIndex = 0;
			endIndex = allReminders.length;
		}
		else if ( HIDE_ALL_REMINDERS ) {
			for ( var x = 0; x < allReminders.length; x++ ) {
				if ( reminderFox_compareDates( allReminders[x].date, todaysDate) != -1 ) {
					break;
				}
			}
			startIndex = x;	
			// need to show reminders of yearly that have passed
			if ( startIndex == allReminders.length ) {				
				startIndex = allReminders.length -1;
			}
		}

		// if there's only 1 reminder and the prefs are set to show prev/next, then just ignore the check
		else if ( !(allReminders.length == 1 && REPEAT_PREVIOUS_OCCURRENCES >= 1 &&  REPEAT_UPCOMING_OCCURRENCES >=1 ) )  {			
			for ( var x = 0; x < allReminders.length; x++ ) {
				if ( reminderFox_compareDates( allReminders[x].date, todaysDate) != -1 ) {
					break;

				}
			}
			if ( REPEAT_PREVIOUS_OCCURRENCES == -1 ) {
				startIndex = 0;
			}
			else {
				startIndex = x - REPEAT_PREVIOUS_OCCURRENCES;
				if ( startIndex < 0 ) {
					startIndex = 0;
				}
			}
			
			if ( REPEAT_UPCOMING_OCCURRENCES == -1 ) {
				endIndex = allReminders.length;
			}
			else {
				endIndex = x + REPEAT_UPCOMING_OCCURRENCES;
				if ( endIndex > allReminders.length ) {
					endIndex = allReminders.length;
				}
			}
		 }
	}
      
   for (  var j = startIndex; j < endIndex; j++ ) {			
		var treeSelection;
		var value ;
		var tree;	
		var boxobject;
		var first;
		var last;
		var previousReminderOffset ;		

		var newItem = document.createElement("treeitem");
		var newRow = document.createElement("treerow");
		newRow.setAttribute( REMINDER_ID_REF, baseReminder.id );
		var newDateLabel = document.createElement("treecell");
		var newDescLabel = document.createElement("treecell");
		
		newItem.appendChild(newRow);
		newRow.appendChild(newDateLabel);
		newRow.appendChild(newDescLabel);
		var isImportant = false;	
		
		var reminder = allReminders[j];		
		reminder = reminderFox_processReminderDescription(reminder, year);		
		
		// if it's marked as RemindUntilComplete, this should be treated as Today's date
	 	if ( reminder.remindUntilCompleted == REMINDERFOX_REMIND_UNTIL_COMPLETE_MARKED && j == startIndex ) {
	 		if (  todaysDate.getFullYear() == year ) {   // only valid for current year in the calendar
	 			reminder = reminderFox_cloneReminderFoxEvent(reminder);
				reminder.date  = new Date( todaysDate.getFullYear(), todaysDate.getMonth(), todaysDate.getDate(), 
					 			reminder.date.getHours(), reminder.date.getMinutes() );	
			}
	 	}
	
		var dayVal = reminder.date.getDate();
		var monthArray = calendarReminderArray[reminder.date.getMonth()];
		if ( monthArray == null ) {
			monthArray = new Array(31);
			calendarReminderArray[reminder.date.getMonth()] = monthArray;
		}

	
		var dayReminderArray = monthArray[dayVal - 1];
		if ( dayReminderArray == null ) {
			dayReminderArray = new Array();
			monthArray[dayVal - 1] = dayReminderArray;
		}

		var  length = dayReminderArray.length;
		dayReminderArray[length] = reminder;

		if ( useDefaultDate ) {
			var monthAsText = reminderFox_getMonthAsText(reminder.date.getMonth());		
			newDateLabel.setAttribute("label", monthAsText + " " + dayVal);
		}
		else {
			newDateLabel.setAttribute("label", reminderFox_getDateVariableString( reminder, reminder.date) );
		}
		newDescLabel.setAttribute("label", reminder.summary);	
		var newTimeLabel = document.createElement("treecell");
		newRow.appendChild(newTimeLabel);		
		
		var newCompletedDateLabel = document.createElement("treecell");
		newRow.appendChild(newCompletedDateLabel);				
		
		var newRepeatLabel = document.createElement("treecell");
		newRow.appendChild(newRepeatLabel);
		
		var newCompleteLabel = document.createElement("treecell");
		newRow.appendChild(newCompleteLabel);
		
		var newRemindUntilCompletedLabel = document.createElement("treecell");
		newRow.appendChild(newRemindUntilCompletedLabel);
		
		var newNotesLabel = document.createElement("treecell");
		newRow.appendChild(newNotesLabel);	
		
	
		if ( reminder.priority == REMINDER_PRIORITY_IMPORTANT) { 
             // mark the date and description as important (red-highlighted)
            newDateLabel.setAttribute("properties", "important");
            newDescLabel.setAttribute("properties", "important");
            newTimeLabel.setAttribute("properties", "important");
            isImportant = true;
         }
         
         if ( reminderFox_isCompletedForDate( reminder, reminder.date ) )  {
        	 newCompleteLabel.setAttribute("src",REMINDER_FOX_COMPLETED_IMAGE);		

			if ( useDefaultDate ) {
				var monthAsText = reminderFox_getMonthAsText(reminder.completedDate.getMonth());		
				newCompletedDateLabel.setAttribute("label", monthAsText + " " + reminder.completedDate.getDate());
			}
			else {
				newCompletedDateLabel.setAttribute("label", reminderFox_getDateVariableString( reminder, reminder.completedDate ) );
			}

        	 if ( isImportant ) {
        	 	newDescLabel.setAttribute("properties", "imporantCompleteText");     	
        	 }
        	 else {
        	 	newDescLabel.setAttribute("properties", "completeText");     	
        	 }
         }
	     
	     setRemindUntilCompleteColumn( reminder, newRemindUntilCompletedLabel );


		if ( reminder.allDayEvent ) {
			newTimeLabel.setAttribute("label", REMINDER_FOX_TIME_ALL_DAY_LABEL);
		}
		else {
			var time = reminderFox_getAddTimeString(reminder);
			if ( time == null ) {
				newTimeLabel.setAttribute("label", REMINDER_FOX_TIME_ALL_DAY_LABEL);
			}
			else {			
				newTimeLabel.setAttribute("label", time);
			}
		}
		
		if ( reminder.recurrence  == REMINDER_RECURRENCE_YEARLY ) {
			newRepeatLabel.setAttribute("label", REPEAT_LABEL_YEARLY);
		}
		else if ( reminder.recurrence  == REMINDER_RECURRENCE_YEARLY_DAY ) {
			newRepeatLabel.setAttribute("label", REPEAT_LABEL_YEARLY_DAY);
		}		
		else 	if ( reminder.recurrence  == REMINDER_RECURRENCE_MONTHLY_DATE ) {
			newRepeatLabel.setAttribute("label", REPEAT_LABEL_MONTHLY);
		}
		else if ( reminder.recurrence  == REMINDER_RECURRENCE_MONTHLY_DAY ) {
			newRepeatLabel.setAttribute("label", REPEAT_LABEL_MONTHLY_DAY);
		}
		else	if ( reminder.recurrence  == REMINDER_RECURRENCE_WEEKLY ) {		
			newRepeatLabel.setAttribute("label", REPEAT_LABEL_WEEKLY);
		}
		else	if ( reminder.recurrence  == REMINDER_RECURRENCE_WEEKLY_ALTERNATING ) {		
			newRepeatLabel.setAttribute("label", REPEAT_LABEL_WEEKLY_ALTERNATING);
		}	
		else	if ( reminder.recurrence  == REMINDER_RECURRENCE_DAILY ) {		
	     	newRepeatLabel.setAttribute("label", REPEAT_LABEL_DAILY);
		}					
		else {		
			newRepeatLabel.setAttribute("label", REPEAT_LABEL_NONE);
		}		
		
	  	if ( reminder.notes != null ) {
     		newNotesLabel.setAttribute("src",REMINDER_FOX_NOTES_IMAGE);			
     	}     
     	
     	if ( reminder.messageID != null ) {
     		var newMailLabel = document.createElement("treecell");
			newRow.appendChild(newMailLabel);	
     		newMailLabel.setAttribute("src",REMINDER_FOX_MAIL_IMAGE);			
     	}
     	
		// Figure out where to put the new item in sorted list
		var treeitems = treeChildren.childNodes;
		var added = false;
		
		for (var i=lastListIndex; i < treeitems.length; i++) {
			var item = treeitems[i];
			var row = item.childNodes[0];
			
			var month;
			var date;
			var dateCell = row.childNodes[0];
			var dateLabel = dateCell.getAttribute("label");			
			if ( useDefaultDate ) {
				var dateLabelDiv = dateLabel.split(" ");
				month = reminderFox_getMonthAsInteger(dateLabelDiv[0]);
				date = dateLabelDiv[1];
			}
			else {
				var monthAndDate = reminderFox_decodeDateVariableString(dateVariableString, dateLabel );
				date = monthAndDate.date;
				month = monthAndDate.month;							
			}			
			
			var timeLabel = row.childNodes[2].getAttribute("label");			
			var allDay = timeLabel == REMINDER_FOX_TIME_ALL_DAY_LABEL;
			
			if (month > reminder.date.getMonth() || (month == reminder.date.getMonth() && dayVal <= date ) ) {	
				if (month == reminder.date.getMonth() && date == dayVal) {
					if ( reminder.allDayEvent && !allDay ) {
						continue;
					}
					else if ( !reminder.allDayEvent && allDay ) {
						// adding hourly reminder; let's add it
					}
					else if ( !reminder.allDayEvent && !allDay ) {
						// two hourly events.  Let's compare the times.
						var currentHours = getTimeHoursFromString(timeLabel);
						var currentMinutes = getTimeMinutesFromString(timeLabel);
						if ( reminder.date.getHours() > currentHours ) {
							continue;
						}
						else if ( reminder.date.getHours() == currentHours &&
							reminder.date.getMinutes() > currentMinutes ) {
								continue;
						}
					}
					else if ( !isImportant ) {
						// if this reminder is not marked as important, add to the 
						// end of the list of today's reminders
						continue;
					}
				}
				treeChildren.insertBefore(newItem, item);
				added = true;
			
				// highlight the newly added reminder in the list
				treeSelection = document.getElementById("reminderTree").view.selection;	
				if ( selectCalendarSync ) {
						treeSelection.select(i);
						// make sure that newly selected row is shown in scroll pane
						value = document.getElementById("treeparent").value;
						tree = document.getElementById("reminderTree");					
						boxobject = tree.boxObject;
						boxobject.QueryInterface(Components.interfaces.nsITreeBoxObject);
						
						first = boxobject.getFirstVisibleRow();
						last = boxobject.getLastVisibleRow();
						if ( i < first || i > last ) {	
							boxobject.scrollToRow(treeitems.length - 1);
							boxobject.scrollToRow(treeitems.length - 9);
						}
											
						previousReminderOffset = 3;
						if ( i < previousReminderOffset ) { 
							boxobject.ensureRowIsVisible(i);
						}
						else {
							boxobject.ensureRowIsVisible(i  - previousReminderOffset);
						}						
				}
				lastListIndex = i;
				break;
			}
		}
			
		if (!added){		
			treeChildren.appendChild(newItem);
			// highlight the newly added reminder in the list
			treeSelection = document.getElementById("reminderTree").view.selection;	
			if ( selectCalendarSync ) {
				treeSelection.select(treeitems.length - 1);
				// make sure that newly selected row is shown in scroll pane
				value = document.getElementById("treeparent").value;
				tree = document.getElementById("reminderTree");					
				boxobject = tree.boxObject;
				boxobject.QueryInterface(Components.interfaces.nsITreeBoxObject);
				
				first = boxobject.getFirstVisibleRow();
				last = boxobject.getLastVisibleRow();
				if ( i < first || i > last ) {	
					boxobject.scrollToRow(treeitems.length - 1);			
					boxobject.scrollToRow(treeitems.length - 9);
				}
				
				previousReminderOffset = 3;
				if ( i < previousReminderOffset ) { 
					boxobject.ensureRowIsVisible(i);
				}
				else {
					boxobject.ensureRowIsVisible(i  - previousReminderOffset);
				}					
			}		
		}
	}
}


function createListItemSorted(reminder) {
	var once = document.getElementById("occurrence");
	var treeChildren = document.getElementById("treechildren");

	var newItem = document.createElement("treeitem");
	var newRow = document.createElement("treerow");
	newRow.setAttribute( REMINDER_ID_REF, reminder.id );
	
	var newDateLabel = document.createElement("treecell");
	var newDescLabel = document.createElement("treecell");
	
	newItem.appendChild(newRow);  
	newRow.appendChild(newDateLabel);
	newRow.appendChild(newDescLabel);
	var isImportant = false;	
	
	var monthAsText = reminderFox_getMonthAsText(reminder.date.getMonth());	
	if ( useDefaultDate ) {
		newDateLabel.setAttribute("label", monthAsText + " " +  reminder.date.getDate());
	}
	else {
		newDateLabel.setAttribute("label", reminderFox_getDateVariableString( reminder, reminder.date ) );
	}	

	newDescLabel.setAttribute("label", reminder.summary);
			
	var newTimeLabel = document.createElement("treecell");
	newRow.appendChild(newTimeLabel);		
	
	var newCompletedDateLabel = document.createElement("treecell");
	newRow.appendChild(newCompletedDateLabel);				
			
	
	var newRepeatLabel = document.createElement("treecell");
	newRow.appendChild(newRepeatLabel);
	
	var newCompleteLabel = document.createElement("treecell");
	newRow.appendChild(newCompleteLabel);
	
	var newRemindUntilCompletedLabel = document.createElement("treecell");
	newRow.appendChild(newRemindUntilCompletedLabel);
	
	var newNotesLabel = document.createElement("treecell");
	newRow.appendChild(newNotesLabel);	

	if ( reminder.priority == REMINDER_PRIORITY_IMPORTANT) { 
         // mark the date and description as important (red-highlighted)
        newDateLabel.setAttribute("properties", "important");
        newDescLabel.setAttribute("properties", "important");
        newTimeLabel.setAttribute("properties", "important");
        isImportant = true;
     }
    
    if ( reminderFox_isCompletedForDate( reminder, reminder.date) )  {
    	   newCompleteLabel.setAttribute("src",REMINDER_FOX_COMPLETED_IMAGE);	
        	 if ( isImportant ) {
        	 	newDescLabel.setAttribute("properties", "imporantCompleteText");     	
        	 }
        	 else {
        	 	newDescLabel.setAttribute("properties", "completeText");     	
        	 } 		
			if ( useDefaultDate ) {
				var monthAsText = reminderFox_getMonthAsText(reminder.completedDate.getMonth());		
				newCompletedDateLabel.setAttribute("label", monthAsText + " " + reminder.completedDate.getDate());
			}
			else {
				newCompletedDateLabel.setAttribute("label", reminderFox_getDateVariableString( reminder, reminder.completedDate ) );
			}        	 
     }
     
	setRemindUntilCompleteColumn( reminder, newRemindUntilCompletedLabel );     
     
     if ( reminder.notes != null ) {
     	  //newNotesLabel.setAttribute("properties", "notes");
     	newNotesLabel.setAttribute("src", REMINDER_FOX_NOTES_IMAGE);			
     }     
     
 	if ( reminder.messageID != null ) {
 		var newMailLabel = document.createElement("treecell");
		newRow.appendChild(newMailLabel);	
 		newMailLabel.setAttribute("src",REMINDER_FOX_MAIL_IMAGE);			
 	}     

	if ( reminder.allDayEvent ) {
		newTimeLabel.setAttribute("label", REMINDER_FOX_TIME_ALL_DAY_LABEL);
	}
	else {
		var time = reminderFox_getAddTimeString(reminder);
		if ( time == null ) {
			newTimeLabel.setAttribute("label", REMINDER_FOX_TIME_ALL_DAY_LABEL);
		}
		else {			
			newTimeLabel.setAttribute("label", time);
		}
	}
	
	if ( reminder.recurrence  == REMINDER_RECURRENCE_YEARLY ) {
		newRepeatLabel.setAttribute("label", REPEAT_LABEL_YEARLY);
	}
	else if ( reminder.recurrence  == REMINDER_RECURRENCE_YEARLY_DAY ) {
		newRepeatLabel.setAttribute("label", REPEAT_LABEL_YEARLY_DAY);
	}		
	else 	if ( reminder.recurrence  == REMINDER_RECURRENCE_MONTHLY_DATE ) {
		newRepeatLabel.setAttribute("label", REPEAT_LABEL_MONTHLY);
	}
	else if ( reminder.recurrence  == REMINDER_RECURRENCE_MONTHLY_DAY ) {
		newRepeatLabel.setAttribute("label", REPEAT_LABEL_MONTHLY_DAY);
	}
	else	if ( reminder.recurrence  == REMINDER_RECURRENCE_WEEKLY ) {		
		newRepeatLabel.setAttribute("label", REPEAT_LABEL_WEEKLY);
	}
	else	if ( reminder.recurrence  == REMINDER_RECURRENCE_WEEKLY_ALTERNATING ) {		
		newRepeatLabel.setAttribute("label", REPEAT_LABEL_WEEKLY_ALTERNATING);
	}		
	else 	if ( reminder.recurrence  == REMINDER_RECURRENCE_DAILY ) {
		newRepeatLabel.setAttribute("label", REPEAT_LABEL_DAILY);
	}
	else {		
		newRepeatLabel.setAttribute("label", REPEAT_LABEL_NONE);
	}		

	treeChildren.appendChild(newItem);	
}

function getCurrentTodoList() {
	var todosArr =	reminderFox_getReminderTodos();
	var tabList = document.getElementById("tabList");	
	var tab =	tabList.selectedItem;
	var tabIndex =	tabList.selectedIndex;
	var index = tab.id.indexOf( ':' );
	if ( tabIndex <= 1 || index == -1 ) {
		name = "ToDo's";
	}
	else {
		name = tab.id.substring( index +1 , tab.id.length );
	}
	var todos = todosArr[name];
	if ( todos == null ) {
		todos = new Array();
		todosArr[name] = todos;
	}
	return todos;
}
	

function createTodoListItem(todo, sort, todaysDate ) {
	var tree ;
	var treeSelection
	var boxobject;
	var item;	

	// if this todo is completed and the user wants to hide completed items,
	// don't add it to the list
	if (HIDE_COMPLETED_ITEMS &&
			 todo.completedDate != null ) { 
		return;	
	}

	var treeChildren = document.getElementById("todoTreechildren");
	var newItem = document.createElement("treeitem");
	var newRow = document.createElement("treerow");
	newRow.setAttribute( REMINDER_ID_REF, todo.id );	
	var newDateLabel = document.createElement("treecell");
	var newDescLabel = document.createElement("treecell");
	 		 		newDescLabel.setAttribute("align", "end");
	
	newItem.appendChild(newRow);
	newRow.appendChild(newDateLabel);
	newRow.appendChild(newDescLabel);
	var isImportant = false;
	
	if ( todo.date != null ) {
		var monthAsText = reminderFox_getMonthAsText(todo.date.getMonth());		
		if ( useDefaultDate ) {
			newDateLabel.setAttribute("label", monthAsText + " " + todo.date.getDate());
		}
		else {
			newDateLabel.setAttribute("label", reminderFox_getDateVariableString( todo, todo.date ) );
		}	
	}

	todo = reminderFox_processReminderDescription(todo,  todaysDate.getFullYear(), true );		
	newDescLabel.setAttribute("label", todo.summary);
	
	var newTimeLabel = document.createElement("treecell");
	newRow.appendChild(newTimeLabel);			
	if ( todo.date != null ) { 
		if ( todo.allDayEvent ) {
			newTimeLabel.setAttribute("label", REMINDER_FOX_TIME_ALL_DAY_LABEL);
		}
		else {
			var time = reminderFox_getAddTimeString(todo);
			if ( time == null ) {
				newTimeLabel.setAttribute("label", REMINDER_FOX_TIME_ALL_DAY_LABEL);
			}
			else {			
				newTimeLabel.setAttribute("label", time);
			}
		}
	}
	
	var newCompletedDateLabel = document.createElement("treecell");
	newRow.appendChild(newCompletedDateLabel);				
			
	
	var newCompletedLabel = document.createElement("treecell");
	newRow.appendChild(newCompletedLabel);

	var newTodoShowInTooltip = document.createElement("treecell");
	newRow.appendChild(newTodoShowInTooltip);
	
	// check for any options that are specified, and mark them in the columns 
	if ( todo.priority == REMINDER_PRIORITY_IMPORTANT) { 
            newDescLabel.setAttribute("properties", "important");
            isImportant = true;
     }
     
     if ( todo.completedDate != null  ) {
     	newCompletedLabel.setAttribute("src",REMINDER_FOX_COMPLETED_TODO_IMAGE);			
    	 if ( isImportant ) {
    	 	newDescLabel.setAttribute("properties", "imporantCompleteText");     	
    	 }
    	 else {
    	 	newDescLabel.setAttribute("properties", "completeText");     	
    	 }
    	 
		if ( useDefaultDate ) {
			var monthAsText = reminderFox_getMonthAsText(todo.completedDate.getMonth());		
			newCompletedDateLabel.setAttribute("label", monthAsText + " " + todo.completedDate.getDate());
		}
		else {
			newCompletedDateLabel.setAttribute("label", reminderFox_getDateVariableString( todo, todo.completedDate ) );
		}    	 
    	 
     }
     
     if ( todo.showInTooltip ) {
         	 newTodoShowInTooltip.setAttribute("src", REMINDER_FOX_SHOW_IN_TOOLTIP_IMAGE);		
     }	
     
	var newNotesLabel = document.createElement("treecell");
	newRow.appendChild(newNotesLabel);	
  	if ( todo.notes != null ) {
 		newNotesLabel.setAttribute("src",REMINDER_FOX_NOTES_IMAGE);			
 		//newNotesLabel.setAttribute("properties", "align='center'");
 		// 	newNotesLabel.setAttribute("align", "end");
     	//newNotesLabel.setAttribute("properties", "notes"); 		
 	}     	
 	
 	if ( todo.messageID != null ) {
 		var newMailLabel = document.createElement("treecell");
		newRow.appendChild(newMailLabel);	
 		newMailLabel.setAttribute("src",REMINDER_FOX_MAIL_IMAGE);			
 	} 	
    
	var treeitems = treeChildren.childNodes;
	if( !sort || treeitems.length == 0 ) {
        treeChildren.appendChild(newItem);
        if ( treeitems.length == 1 ) {
            var treeSelection = document.getElementById("todoTree").view.selection;	
			treeSelection.select(0);
        }
	}
    // if current todo is not important, add after important items
    else if ( !isImportant) {
		var added = false;
		for (var i=0; i < treeitems.length && !added; i++) {
			item = treeitems[i];
			var row = item.childNodes[0];
			var todoRefId = row.getAttribute(REMINDER_ID_REF);			
			var todoAtIndex = reminderFox_getTodosById( todoRefId,  getCurrentTodoList() );		

			var descCell = row.childNodes[0];
			var descLabel = descCell.getAttribute("label");		
 			if ( !todoAtIndex.priority == REMINDER_PRIORITY_IMPORTANT ) {
	        	if (  todo.showInTooltip ) {
	     			treeChildren.insertBefore(newItem, item);
					added = true;	        	
					// highlight the newly added reminder in the list
					tree = document.getElementById("todoTree");	
					treeSelection = tree.view.selection;	
					treeSelection.select(i);					
	
					boxobject = tree.boxObject;
					boxobject.ensureRowIsVisible(i);
				}
	        	else {
	        		if ( !todoAtIndex.showInTooltip  ) {
						treeChildren.insertBefore(newItem, item);
						added = true;
						// highlight the newly added reminder in the list
						tree = document.getElementById("todoTree");	
						treeSelection = tree.view.selection;	
						treeSelection.select(i);
						
						boxobject = tree.boxObject;
						boxobject.ensureRowIsVisible(i);
	        		}
	        	}
	        
	        }
		}
	
    	if ( !added ) {
           	treeChildren.appendChild(newItem);
			// highlight the newly added reminder in the list 	 
	    	tree = document.getElementById("todoTree");	
	    	treeSelection = tree.view.selection;	
			treeSelection.select(treeitems.length - 1);			
							
			boxobject = tree.boxObject;
			boxobject.ensureRowIsVisible(treeitems.length - 1);
       }
    }
    // new Todo is important - add to top of list
    else {        		
    	item = treeitems[0];
    	treeChildren.insertBefore(newItem, item);
		added = true;	
		// highlight the newly added reminder in the list
		tree = document.getElementById("todoTree");	
		treeSelection = tree.view.selection;	
		treeSelection.select(0);

		boxobject = tree.boxObject;
		boxobject.ensureRowIsVisible(0);
    }	
}


function createTodoListItemAtIndex(todo, index) {
	var tree ;
	var treeSelection
	var boxobject;
	var item;	
	
	var treeChildren = document.getElementById("todoTreechildren");
	var newItem = document.createElement("treeitem");
	var newRow = document.createElement("treerow");
	newRow.setAttribute( REMINDER_ID_REF, todo.id );	
	var newDateLabel = document.createElement("treecell");	
	var newDescLabel = document.createElement("treecell");

	newItem.appendChild(newRow);
	newRow.appendChild(newDateLabel);
	newRow.appendChild(newDescLabel);
	var isImportant = false;
	
	if ( todo.date != null ) {
		var monthAsText = reminderFox_getMonthAsText(todo.date.getMonth());		
		if ( useDefaultDate ) {
			newDateLabel.setAttribute("label", monthAsText + " " + todo.date.getDate());
		}
		else {
			newDateLabel.setAttribute("label", reminderFox_getDateVariableString( todo, todo.date ) );
		}	
	}	
	todo = reminderFox_processReminderDescription(todo,  new Date().getFullYear(), true );			
	newDescLabel.setAttribute("label", todo.summary);
	var newTimeLabel = document.createElement("treecell");
	newRow.appendChild(newTimeLabel);			
	if ( todo.date != null ) { 
		if ( todo.allDayEvent ) {
			newTimeLabel.setAttribute("label", REMINDER_FOX_TIME_ALL_DAY_LABEL);
		}
		else {
			var time = reminderFox_getAddTimeString(todo);
			if ( time == null ) {
				newTimeLabel.setAttribute("label", REMINDER_FOX_TIME_ALL_DAY_LABEL);
			}
			else {			
				newTimeLabel.setAttribute("label", time);
			}
		}	
	}
	
	var newCompletedDateLabel = document.createElement("treecell");
	newRow.appendChild(newCompletedDateLabel);				
			

	var newCompletedLabel = document.createElement("treecell");
	newRow.appendChild(newCompletedLabel);
				
	var newTodoShowInTooltip = document.createElement("treecell");
	newRow.appendChild(newTodoShowInTooltip);
	
	// check for any options that are specified, and mark them in the columns 
	if ( todo.priority == REMINDER_PRIORITY_IMPORTANT) { 
            newDescLabel.setAttribute("properties", "important");
            isImportant = true;
     }
     
     if ( todo.completedDate != null  ) {
     	newCompletedLabel.setAttribute("src",REMINDER_FOX_COMPLETED_TODO_IMAGE);	
    	 if ( isImportant ) {
    	 	newDescLabel.setAttribute("properties", "imporantCompleteText");     	
    	 }
    	 else {
    	 	newDescLabel.setAttribute("properties", "completeText");     	
    	 }    
    	  		
		if ( useDefaultDate ) {
			var monthAsText = reminderFox_getMonthAsText(todo.completedDate.getMonth());		
			newCompletedDateLabel.setAttribute("label", monthAsText + " " + todo.completedDate.getDate());
		}
		else {
			newCompletedDateLabel.setAttribute("label", reminderFox_getDateVariableString( todo, todo.completedDate ) );
		}     	 	
     }     
     
     if ( todo.showInTooltip ) {	
         	 newTodoShowInTooltip.setAttribute("src", REMINDER_FOX_SHOW_IN_TOOLTIP_IMAGE);		         
     }	
	
	var newNotesLabel = document.createElement("treecell");
	newRow.appendChild(newNotesLabel);	
  	if ( todo.notes != null ) {
 		newNotesLabel.setAttribute("src",REMINDER_FOX_NOTES_IMAGE);			
 		//newNotesLabel.setAttribute("properties", "align='center'");
 		newNotesLabel.setAttribute("align", "end");
     	//newNotesLabel.setAttribute("properties", "notes"); 			
 	}     	     
 	if ( todo.messageID != null ) {
 		var newMailLabel = document.createElement("treecell");
		newRow.appendChild(newMailLabel);	
 		newMailLabel.setAttribute("src",REMINDER_FOX_MAIL_IMAGE);			
 	} 	 	
    
	var treeitems = treeChildren.childNodes;	
	// insert at end if last item
	if ( index >= treeitems.length ) {
        treeChildren.appendChild(newItem);
        // highlight the newly added reminder in the list 	 
        tree = document.getElementById("todoTree");	
        treeSelection = tree.view.selection;	
        treeSelection.select(treeitems.length -1 );			
                        
        boxobject = tree.boxObject;
        boxobject.ensureRowIsVisible(treeitems.length -1 );	
	
	}
	else {
		// otherwise insert before current item at index
		item = treeitems[index ];
		treeChildren.insertBefore(newItem, item);
		
		tree = document.getElementById("todoTree");	
		treeSelection = tree.view.selection;	
		treeSelection.select(index);					
	
		boxobject = tree.boxObject;
		boxobject.ensureRowIsVisible(index);	
	}
}


/**
  * select (highlight) today's reminder or the next upcoming reminder
  */
function highlightClosestUpcomingReminder(currentDate) {
	var currentMonth = currentDate.getMonth();
	var currentDay = currentDate.getDate();
	var treeChildren = document.getElementById("treechildren");
	var treeitems = treeChildren.childNodes;

	for (var i=0; i < treeitems.length; i++) {
		var item = treeitems[i];
		var row = item.childNodes[0];
		
		var month;
		var date;
		var dateCell = row.childNodes[0];
		var dateLabel = dateCell.getAttribute("label");
		if ( useDefaultDate ) {
			var dateLabelDiv = dateLabel.split(" ");
			month = reminderFox_getMonthAsInteger(dateLabelDiv[0]);
			date = parseInt(dateLabelDiv[1]);
		}
		else {
			var monthAndDate = reminderFox_decodeDateVariableString(dateVariableString, dateLabel );
			date = monthAndDate.date;
			month = monthAndDate.month
		}
		

		if ( month > currentMonth || (month == currentMonth && date >= currentDay ) ) {
			var treeSelection = document.getElementById("reminderTree").view.selection		
			treeSelection.select(i);
			
			// make sure that newly selected row is shown in scroll pane
			var value = document.getElementById("treeparent").value;
		  	var tree = document.getElementById("reminderTree");			
			var boxobject = tree.boxObject;
			boxobject.QueryInterface(Components.interfaces.nsITreeBoxObject);
			
			// make sure it shows up at the top if possible
			var first = boxobject.getFirstVisibleRow();
			var last = boxobject.getLastVisibleRow();
			if ( i < first || i > last ) {				
				boxobject.scrollToRow(treeitems.length - 9);
			}
			
			var previousReminderOffset = 3;
			if ( i < previousReminderOffset ) { 
				boxobject.ensureRowIsVisible(i);
			}
			else {
				boxobject.ensureRowIsVisible(i  - previousReminderOffset);
			}
			break;
		}
	}
}

/**
  * select (highlight) today's reminder or the next upcoming reminder
  */
function highlightReminderForDate(currentMonth, currentDay) { 
	var highlighted = false;
	var treeChildren = document.getElementById("treechildren");
	var treeitems = treeChildren.childNodes;
	for (var i=0; i < treeitems.length; i++) {
		var item = treeitems[i];
		var row = item.childNodes[0];
		
		var month;
		var date;
		var dateCell = row.childNodes[0];
		var dateLabel = dateCell.getAttribute("label");		
		if ( useDefaultDate ) {
			var dateLabelDiv = dateLabel.split(" ");
			month = reminderFox_getMonthAsInteger(dateLabelDiv[0]);
			date = parseInt(dateLabelDiv[1]);
		}
		else {
			var monthAndDate = reminderFox_decodeDateVariableString(dateVariableString, dateLabel );
			date = monthAndDate.date;
			month = monthAndDate.month
		}		

		if ( month == currentMonth && date == currentDay ) {
			highlighted = true;
			var treeSelection = document.getElementById("reminderTree").view.selection		
			treeSelection.select(i);

			// make sure that newly selected row is shown in scroll pane
			var value = document.getElementById("treeparent").value;
		  	var tree = document.getElementById("reminderTree");			
			var boxobject = tree.boxObject;
			boxobject.QueryInterface(Components.interfaces.nsITreeBoxObject);
			
			// make sure it shows up at the top if possible
			var first = boxobject.getFirstVisibleRow();
			var last = boxobject.getLastVisibleRow();
			
			if ( i <= first || i >= last ) {				
				boxobject.scrollToRow(treeitems.length - 9);
			}
			
			var previousReminderOffset = 3;
			if ( i < previousReminderOffset ) { 
				boxobject.ensureRowIsVisible(i);
			}
			else {
				boxobject.ensureRowIsVisible(i  - previousReminderOffset);
			}
			break;
		}
	}
	
	if ( !highlighted ) {
		selectNewReminderText();
	}
}

function highlightTodo() {
	var tree = document.getElementById("todoTree");			
	var treeSelection = tree.view.selection;	
	treeSelection.select(0);	
	treeSelection.clearSelection();
			
	var boxobject = tree.boxObject;
	boxobject.ensureRowIsVisible(0);	
}


function removeListItemsForReminder(reminder) {
	var treeChildren = document.getElementById("treechildren");
	var treeitems = treeChildren.childNodes;
	for (var i=treeitems.length - 1; i >= 0; i--) {
		var item = treeitems[i];
		var row = item.childNodes[0];
		var reminderRefId = row.getAttribute(REMINDER_ID_REF);	
		if ( reminderRefId == reminder.id ) {			
			treeChildren.removeChild(item);
		}
	}
}

function removeTodoListItem(todo) {
	var treeChildren = document.getElementById("todoTreechildren");
	var treeitems = treeChildren.childNodes;

	for (var i=0; i < treeitems.length; i++) {
		var item = treeitems[i];
		var row = item.childNodes[0];
		var todoRefId = row.getAttribute(REMINDER_ID_REF);		
		if ( todoRefId == todo.id ) {			
			treeChildren.removeChild(item);
			break;
		}
	}	
}


// saves and closes the 'edit reminders' dialog
function revert() {
	// there were changes.  Prompt user to revert/cancel
	// get a reference to the prompt service component.
	var promptService = Components.classes["@mozilla.org/embedcomp/prompt-service;1"]
	                    .getService(Components.interfaces.nsIPromptService);

	var flags=promptService.BUTTON_TITLE_IS_STRING * promptService.BUTTON_POS_0 +
   	promptService.BUTTON_TITLE_IS_STRING * promptService.BUTTON_POS_1;     
	var msg =  g_reminderFoxBundle.getString("rf.add.revert.description");
	var buttonPressed = promptService.confirmEx(window,g_reminderFoxBundle.getString("rf.add.revert.title"),
	  msg,
	  flags, g_reminderFoxBundle.getString("rf.add.revert.button.revert.title"), g_reminderFoxBundle.getString("rf.button.cancel"), null, null, {});		  
	  
	// revert pressed
	if ( buttonPressed == 0 ) {		
		revertActions();
	}	
}

function removeAllListItems(removeReminders, removeTodos) {
	if ( removeReminders ) {
		var reminderTree = document.getElementById("reminderTree");
		var treeChildren = document.getElementById("treechildren");
		reminderTree.removeChild(treeChildren);
		
		var newchildren = document.createElement("treechildren");
		newchildren.setAttribute("id", "treechildren");
		newchildren.setAttribute("ondblclick", "if (event.button == 0) editReminder()");
		newchildren.setAttribute("onclick", "reminderFox_toggleReminderColumns(event);");		
		
		newchildren.setAttribute("tooltip", "reminderTree-tooltip");
		reminderTree.appendChild(newchildren);
	}

	if ( removeTodos ) {
		var todoTreeChildren = document.getElementById("todoTreechildren");
	     while (todoTreeChildren.hasChildNodes()) {
	    	 todoTreeChildren.removeChild(todoTreeChildren.firstChild);
	  	 }		
	 }	
}


// saves and closes the 'edit reminders' dialog
function saveSettings(isCloseDemanded) {
	var currentDate = new Date();
	var day = currentDate.getDate();
	var windowEnumerator = reminderFox_getWindowEnumerator();
	var currentWindow;
	var daysChanged = false;


	// see if the day has changed since last process
	if (windowEnumerator.hasMoreElements()) {
		currentWindow = windowEnumerator.getNext();		
		if ( currentWindow.reminderFox_lastDay != day ) {
			daysChanged = true;
		}
	}

	// if any events were modified or the day has changed, we want to update the tooltip and status text
	if ( g_modified || daysChanged ) {  
		reminderFox_processRecentReminders();
		
		reminderFox_writeOutRemindersAndTodos(false);
		try {
			// update all of the browsers
			windowEnumerator =  reminderFox_getWindowEnumerator();
			while (windowEnumerator.hasMoreElements()) {
				var currentWindow = windowEnumerator.getNext();		
				currentWindow.reminderFoxEvents = reminderFoxEvents;
				currentWindow.reminderFoxTodosArray  = reminderFoxTodosArray; 

				currentWindow.reminderFox_updateRemindersInWindow();			
				currentWindow.reminderFox_clearRemindersAndTodos();
				
			}			
			// this callback syncs the written changes to remote and does it in the background on the calling 
			// window (otherwise we have to keep this window open until the network function callback returns)
			var syncCallback = window.arguments[1].callback;
			if ( syncCallback != null ) {				
				var networkSync = REMINDER_FOX_NETWORK_SYNCHRONIZE_DEFAULT;		
				try {
					networkSync = reminderFox_prefs.getBoolPref(REMINDER_FOX_PREF + "." + REMINDER_FOX_NETWORK_SYNCHRONIZE);
				} catch(e) {
				}	
				if ( networkSync ) {				
					syncCallback();			
				}
			}	
		}
		catch(e) {
		}
	}
	else {
		 reminderFox_ensureRemindersSynchronized(); 
	}
	
	// clear reminders from memory
	reminderFox_clearRemindersAndTodos();
	g_modified = false;

}
function dblClickDay(newDayItemNumber) {
   var dayNumberItem = document.getElementById( "oe-date-picker-month-day-text-" + newDayItemNumber );
   var dayNumber = dayNumberItem.getAttribute( "value" );
   
   // they may have clicked an unfilled day, if so ignore it and leave the picker up   
   if( dayNumber != "" )  {
		addReminder();
   }
}

// Adds the new reminder from the edit reminder dialog
function addReminder() {
	var newDate = oeDatePicker.gSelectedDate;
	if ( newDate == null ) {
		newDate = new Date();
	}	
	var originalYear = newDate.getFullYear();

	var reminderId =reminderFox_generateUniqueReminderId( newDate );
	var	newReminderToBeAdded = new ReminderFoxEvent( reminderId, newDate, "" );

	var newOptions = { reminder: newReminderToBeAdded, editing:  false,  addReminder: false };
	window.openDialog("chrome://reminderfox/content/reminderOptionsDialog.xul",
			"reminderOptionsDialog", "chrome,resizable,modal", newOptions );

	if ( newOptions.addReminder ) {
		var currentDate = new Date();
		if ( newReminderToBeAdded.alarm != null ) {
			newReminderToBeAdded.alarmLastAcknowledge = currentDate.getTime();
		}
		newReminderToBeAdded.lastModified = reminderFox_getDateAsString(currentDate );
		
		// if adding a new reminder in a different year, first set the list/calendar to the new year 
		// before adding the reminder
		if ( originalYear != newReminderToBeAdded.date.getFullYear() ) {
		   	oeDatePicker.gSelectedDate = newReminderToBeAdded.date;
			repopulateListForYear( originalYear, newReminderToBeAdded.date.getFullYear() );
		}
	
		// add reminder in sorted order...
		var reminders = reminderFox_getReminderEvents();	
		var sortedIndex = reminderFox_getSortedIndexOfNewReminder( reminders, newReminderToBeAdded, false );
		reminderFox_insertIntoArray( reminders, newReminderToBeAdded, sortedIndex );
		
		createListItem(newReminderToBeAdded);
		oeDatePicker.onpopupshowing(newReminderToBeAdded.date);
		
		modifiedReminders();
	}
}

function modifiedReminders() {
	g_modified = true;

	var revertButton= document.getElementById("revertbutton");
	revertButton.setAttribute( "disabled", false );
	
	var revertButtonTodos= document.getElementById("revertbuttonTodos");
	revertButtonTodos.setAttribute( "disabled", false );
}

function addTodo() {
	var todoId =reminderFox_generateUniqueTodoId();
	
	var newTodo = new ReminderFoxTodo(todoId, "" );


	var tabList = document.getElementById("tabList");	
	var tabIndex =	tabList.selectedIndex;
	if ( tabIndex <= 1 ) {
		newTodo.showInTooltip = true;
	}
	else {
		newTodo.showInTooltip = false;   // for custom lists, default to false for show in tooltip
	}

	var newOptions = { todo: newTodo, editing:  false,  addTodo: false };
	window.openDialog("chrome://reminderfox/content/todoOptionsDialog.xul",
			"todoOptionsDialog", "chrome,resizable,modal", newOptions );

	if ( newOptions.addTodo ) {
		if ( newTodo.alarm != null ) {
			var currentDate = new Date();
			newTodo.alarmLastAcknowledge = currentDate.getTime();
		}
		// add todo in sorted order...
		var todos = getCurrentTodoList();
		var sortedIndex = reminderFox_getSortedIndexOfNewTodo(todos,  newTodo );
		reminderFox_insertIntoArray( todos, newTodo, sortedIndex );
		createTodoListItem(newTodo, true, new Date());
		modifiedReminders();
	}
	
}

function editTodo() {
	var currentTodo = getTodoForSelectedItem( );

	var newOptions = { todo: currentTodo, editing:  true,  addTodo: false };
	window.openDialog("chrome://reminderfox/content/todoOptionsDialog.xul",
			"todoOptionsDialog", "chrome,resizable,modal", newOptions );

	if ( newOptions.addTodo ) {		 	
 		currentTodo = reminderFox_processReminderDescription(currentTodo,  new Date().getFullYear(), true );	
		var modified = updateTodoInList( currentTodo );
		modifiedReminders();
		var newDate = new Date();
		if ( currentTodo.alarm != null ) {
			currentTodo.alarmLastAcknowledge = newDate.getTime();
		}		
		
	}
	
}


function removeReminder() {
	var currentReminder = getReminderForSelectedItem( );

	// remove from UI list
	removeListItemsForReminder(currentReminder);
	
	// remove from model list
	var reminders = reminderFox_getReminderEvents();	
	for( var i = 0; i < reminders.length; i++) {
		if ( reminders[i].id == currentReminder.id ) {
			reminderFox_removeElement(reminders, i);
			break;
		}
	}
}


function removeTodo() {
	var currentTodo = getTodoForSelectedItem();
	if ( currentTodo != null ) {
		// remove from UI list
		removeTodoListItem(currentTodo);
		
		// remove from model list
		var todos = getCurrentTodoList();
		for( var i = 0; i < todos.length; i++) {
			if ( todos[i].id == currentTodo.id ) {
				reminderFox_removeElement(todos, i);
				break;
			}
		}
	}

}

function activateCalendarContext(event, newDayItemNumber) {
   var dayNumberItem = document.getElementById( "oe-date-picker-month-day-text-" + newDayItemNumber );
   var dayNumber = dayNumberItem.getAttribute( "value" );
   
   // they may have clicked an unfilled day, if so ignore it and leave the picker up   
   if( dayNumber != "" )  {
		var tree = document.getElementById("reminderTree");
		var treeContextMenu = document.getElementById("treechildren-calendar-contextmenu");
	
		document.popupNode = tree;
		var noExistingReminder = false;
	
		// modify context menu depending on Important reminder status
		var selectedTreeItemIndex = document.getElementById("reminderTree").currentIndex;
		if ( selectedTreeItemIndex == -1 ) {
			noExistingReminder = true;
		}
		treeContextMenu.showPopup(tree, event.clientX, event.clientY, "bottomleft", "topleft");
		var currentReminder = getReminderForSelectedItem( );
		if ( currentReminder == null ) {
			noExistingReminder = true;
		}
		// check that it's pointing to the current date; otherwise it means there is no current reminder for this date
		else 	{
				if ( !noExistingReminder ) {
					// check the date from the tree list, as the actual reminder could have an earlier date (if it's
					// set for RemindUntilComplete, for example)
					var treeChildren = document.getElementById("treechildren");
					var selectedTreeItem = treeChildren.childNodes[selectedTreeItemIndex];
					
					var day;
					var dateLabel = selectedTreeItem.childNodes[0].childNodes[0].getAttribute("label");					
					if ( useDefaultDate ) {
						var dateLabelArray = dateLabel.split(" ");	
						day = dateLabelArray[1];
					}
					else {
						var monthAndDate = reminderFox_decodeDateVariableString(dateVariableString, dateLabel );
						day = monthAndDate.date;
					}					
					if ( day != dayNumber ) {
						noExistingReminder = true;
					}
				}
		}
		
		var contextMenuImportant = document.getElementById("treechildren-calendar-contextmenu-important");	
		var contextMenuRemindComplete = document.getElementById("treechildren-calendar-contextmenu-remindUntilComplete");			
		var contextMenuComplete = document.getElementById("treechildren-calendar-contextmenu-markAsComplete");	
		var contextEdit = document.getElementById("treechildren-calendar-contextmenu-edit");			
		var contextDelete= document.getElementById("treechildren-calendar-contextmenu-delete");			
		var contextMoveToTodos = document.getElementById("treechildren-calendar-contextmenu-moveToTodos");			
		if ( noExistingReminder ) {
			contextEdit.setAttribute( "disabled", true );
			contextDelete.setAttribute( "disabled", true );			
			contextMoveToTodos.setAttribute( "disabled", true );						
			contextMenuImportant.setAttribute( "disabled", true );
			contextMenuRemindComplete.setAttribute( "disabled", true );
			contextMenuComplete.setAttribute( "disabled", true );			

			contextMenuImportant.setAttribute("checked", "false");	
			contextMenuRemindComplete.setAttribute("checked", "false");	 
			contextMenuComplete.setAttribute("checked", "false");					
		}		
		else {
			contextEdit.removeAttribute( "disabled" );
			contextDelete.removeAttribute( "disabled" );
			contextMoveToTodos.removeAttribute( "disabled" );
			contextMenuImportant.removeAttribute( "disabled" );
			contextMenuRemindComplete.removeAttribute( "disabled" );
			contextMenuComplete.removeAttribute( "disabled" );
					
			if ( currentReminder.priority != REMINDER_PRIORITY_IMPORTANT ) {
				contextMenuImportant.setAttribute("checked", "false");	
			}
			else {
				contextMenuImportant.setAttribute("checked", "true");	
			}
			
			if ( currentReminder.remindUntilCompleted != REMINDERFOX_REMIND_UNTIL_COMPLETE_NONE) {
				contextMenuRemindComplete.setAttribute("checked", "true");	 
			}
			else {
				contextMenuRemindComplete.setAttribute("checked", "false");	 
			}
			
			
			if ( currentReminder.completedDate == null ) {
					contextMenuComplete.setAttribute("checked", "false");	
			}
			else {
				var treeChildren = document.getElementById("treechildren");
				var selectedTreeItem = treeChildren.childNodes[selectedTreeItemIndex];
				var year = oeDatePicker.gSelectedDate.getFullYear();
				if ( year == null ) {
					year = new Date().getFullYear();
				}		
				var dateLabel = selectedTreeItem.childNodes[0].childNodes[0].getAttribute("label");
				var monthAndDate = reminderFox_decodeDateVariableString(dateVariableString, dateLabel );
				day = monthAndDate.date;
				monthAsInteger = monthAndDate.month;				
				reminderInstanceDate = new Date( year, monthAsInteger, day );	
				
		
				if ( reminderFox_isCompletedForDate( currentReminder, reminderInstanceDate ) )  {
						contextMenuComplete.setAttribute("checked", "true");	
				}
				else {
					contextMenuComplete.setAttribute("checked", "false");	
				}
			}
				
			
		}
		

   }
    
}

function activateContext(event) {
	var tree = document.getElementById("reminderTree");
	var treeContextMenu = document.getElementById("treechildren-contextmenu");

	document.popupNode = tree;
	
	
	// show current lists...
	var moveToList = document.getElementById("treechildren-contextmenu-moveReminderToList-popup");	
	while (moveToList.hasChildNodes()) {
		 moveToList.removeChild(moveToList.firstChild);
	}
	var tabList = document.getElementById("tabList");	
	var tab =	tabList.selectedItem;
	var tabIndex =	tabList.selectedIndex;
	for ( var i = 1; i < tabList.childNodes.length; i++ ) {  // i =1, because we want to skip reminders
		var tablistItem = tabList.childNodes[i];	
		var tabLabel = tablistItem.getAttribute("label");
		var menuItem = document.createElement("menuitem");
		menuItem.setAttribute( "label", tabLabel );
		menuItem.setAttribute( "oncommand", "userMoveReminderToTodo(event.target)");
		moveToList.appendChild(menuItem);
	}	
	
	// modify context menu depending on Important reminder status
	var selectedTreeItemIndex = document.getElementById("reminderTree").currentIndex;
	if ( selectedTreeItemIndex == -1 ) {
		return;
	}
	treeContextMenu.showPopup(tree, event.clientX, event.clientY, "bottomleft", "topleft"); 
	
	var currentReminder = getReminderForSelectedItem( );
	if ( currentReminder == null ) {
		return;
	}

	var contextMenuImportant = document.getElementById("treechildren-contextmenu-important");	
	if ( currentReminder.priority != REMINDER_PRIORITY_IMPORTANT ) {
		contextMenuImportant.setAttribute("checked", "false");	
	}
	else {
		contextMenuImportant.setAttribute("checked", "true");	
	}
	
	var contextMenuRemindComplete = document.getElementById("treechildren-contextmenu-remindUntilComplete");	
	if ( currentReminder.remindUntilCompleted != REMINDERFOX_REMIND_UNTIL_COMPLETE_NONE) {
		contextMenuRemindComplete.setAttribute("checked", "true");	 
	}
	else {
		contextMenuRemindComplete.setAttribute("checked", "false");	 
	}

	var contextMenuComplete = document.getElementById("treechildren-contextmenu-markAsComplete");	
	if ( currentReminder.completedDate == null ) {
			contextMenuComplete.setAttribute("checked", "false");	
	}
	else {
		var treeChildren = document.getElementById("treechildren");
		var selectedTreeItem = treeChildren.childNodes[selectedTreeItemIndex];
		var year = oeDatePicker.gSelectedDate.getFullYear();
		if ( year == null ) {
			year = new Date().getFullYear();
		}		
		var dateLabel = selectedTreeItem.childNodes[0].childNodes[0].getAttribute("label");
		var monthAndDate = reminderFox_decodeDateVariableString(dateVariableString, dateLabel );
		day = monthAndDate.date;
		monthAsInteger = monthAndDate.month;				
		reminderInstanceDate = new Date( year, monthAsInteger, day );			

		if ( reminderFox_isCompletedForDate( currentReminder, reminderInstanceDate ) )  {
				contextMenuComplete.setAttribute("checked", "true");	
		}
		else {
			contextMenuComplete.setAttribute("checked", "false");	
		}
	}
		
	// If reminder is associated with an email, show the View Mail context menu item.  Otherwise, do not.
    var showMail = document.getElementById("treechildren-contextmenu-showMail");	
    if ( showMail != null ) {
		if ( currentReminder.messageID == null  ) {
			showMail.setAttribute("hidden", "true");	
		}
		else {
			showMail.setAttribute("hidden", "false");	
		}
	}
}

function reminderFox_toggleReminderColumns(event){
	  var row = {}, column = {}, part = {};
	  var tree = document.getElementById("reminderTree");
	  var boxobject = tree.boxObject;
	  boxobject.QueryInterface(Components.interfaces.nsITreeBoxObject);
	  boxobject.getCellAt(event.clientX, event.clientY, row, column, part);

	  
	var rowIndex = row.value;
	if ( rowIndex != -1 ) { 
		var  treeSelection = document.getElementById("reminderTree").view.selection;
		treeSelection.select(rowIndex);
		
		if (typeof column.value != "string") {
	  		column.value = column.value.id;
	 	 }

		if ( column.value == "remindUntilCompletedColLabel" ) {
			toggleRemindUntilCompleted();
		}
		else if ( column.value == "CompleteColLabel" ) {
			toggleMarkAsComplete();
		}
		else if ( column.value == "mailColLabel" ) {
			reminderFox_doShowMail();
		}		
	}
}

function reminderFox_toggleTodoColumns(event){
	  var row = {}, column = {}, part = {};
	  var tree = document.getElementById("todoTree");
	  var boxobject = tree.boxObject;
	  boxobject.QueryInterface(Components.interfaces.nsITreeBoxObject);
	  boxobject.getCellAt(event.clientX, event.clientY, row, column, part);
	  
	var rowIndex = row.value;
	if ( rowIndex != -1 ) { 
		var  treeSelection = document.getElementById("todoTree").view.selection;
		treeSelection.select(rowIndex);
		
	    if (typeof column.value != "string") {
		 	column.value = column.value.id;
		}
	
		if ( column.value == "todoShowInTooltip" ) {
			toggleTodoShowInTooltip();
		}
		else if ( column.value == "todoCompleteColLabel" ) {
			toggleTodoMarkAsComplete();
		}
		else if ( column.value == "todoMailColLabel" ) {
			reminderFox_doShowMailTodo();
		}				
	}
}


function reminderTreeTooltip(event) {
 	var tree = document.getElementById("reminderTree");
 	var boxobject = tree.boxObject;
  	boxobject.QueryInterface(Components.interfaces.nsITreeBoxObject);  // cast to treeboxobject to use getRowAt
  	//boxobject.getCellAt(event.clientX, event.clientY, row, column, part);
  
 	var index = tree.boxObject.getRowAt( event.clientX, event.clientY );
 	if ( index == -1 ) {
 		return false;  // returning false causes tooltip to not show
 	} 	
 	var treeChildren = document.getElementById("treechildren");
 	var selectedTreeItem = treeChildren.childNodes[index];
	var reminderRefId = selectedTreeItem.childNodes[0].getAttribute(REMINDER_ID_REF);
	var reminder =  reminderFox_getRemindersById( reminderRefId );
 	if ( reminder == null ) {
 		return false; // returning false causes tooltip to not show
 	}
 	
 	var currentDate = oeDatePicker.gSelectedDate;
	if ( currentDate == null ) {
		currentDate = new Date();
	}	
	reminder = reminderFox_processReminderDescription(reminder,  currentDate.getFullYear());	
 	var title = document.getElementById("reminderTree-tooltip-title"); 
  	title.setAttribute("value", reminder.summary);

   	 var tooltipItem = document.getElementById( "reminderTree-tooltip-notes");
     while (tooltipItem.hasChildNodes()) {
    	 	tooltipItem.removeChild(tooltipItem.firstChild);
  	 }

	// add notes to to tooltip (if applicable)			  	 	
 	if ( reminder.notes != null ) {
  	 	addNotesToTooltip( reminder.notes, tooltipItem );
   }
   return true;
}


function todoTreeTooltip(event) {
 	var tree = document.getElementById("todoTree");
 	var boxobject = tree.boxObject;
  	boxobject.QueryInterface(Components.interfaces.nsITreeBoxObject);  // cast to treeboxobject to use getRowAt
  	//boxobject.getCellAt(event.clientX, event.clientY, row, column, part);
  
 	var index = tree.boxObject.getRowAt( event.clientX, event.clientY );
 	if ( index == -1 ) {
 		return false; // returning false causes tooltip to not show
 	}
 	var treeChildren = document.getElementById("todoTreechildren");
 	var selectedTreeItem = treeChildren.childNodes[index];
	var todoRefId = selectedTreeItem.childNodes[0].getAttribute(REMINDER_ID_REF);
	var todo =  reminderFox_getTodosById( todoRefId,  getCurrentTodoList() );
 	if ( todo == null ) {
 		return false; // returning false causes tooltip to not show
 	}
 	
 	todo = reminderFox_processReminderDescription(todo,  new Date().getFullYear(), true );	
 	
 	var title = document.getElementById("todoTree-tooltip-title");
  	title.setAttribute("value", todo.summary);

   	 var tooltipItem = document.getElementById( "todoTree-tooltip-notes");
     while (tooltipItem.hasChildNodes()) {
    	 tooltipItem.removeChild(tooltipItem.firstChild);
  	 }
  
   	// add notes to to tooltip (if applicable)			  	 	
 	if ( todo.notes != null ) {
  	 	addNotesToTooltip( todo.notes, tooltipItem );
   }
   return true;
}

function addNotesToTooltip( orignotes, tooltipItem    ) {
 	var newline = "\n";
 	
 	// replace all tab characters with spaces (otherwise shows up as weird character)
 	var notes = orignotes.replace(new RegExp(/\t/g),"    ");  
	var separatedString = notes.split(newline);	
	var tooltipWrapLength = 120;
	var remLabel;
	for ( var i = 0; i < separatedString.length; i++ ) {
		var noteLine = separatedString[i];
		var afterFirst = false;
		while ( noteLine.length > tooltipWrapLength  ) {		
			// go back to last whitespace
			var lastIndex = noteLine.lastIndexOf( ' ', tooltipWrapLength );
			var forceLineBreak = false;
			if ( lastIndex == -1 ) {
				forceLineBreak = true;
		    	lastIndex = tooltipWrapLength + 1;
			}
			if ( lastIndex != -1 ) {
			    var curStr = noteLine.substring( 0, lastIndex );				    	    
			    remLabel = document.createElement("description");
				remLabel.setAttribute("value", curStr);
				tooltipItem.appendChild(remLabel);
				afterFirst = true;
			}
			
			if ( forceLineBreak ) {
				startIndex = lastIndex;
			}
			else {
				startIndex = lastIndex + 1;
			}
			noteLine = noteLine.substring( startIndex );		  										
		}			
		remLabel = document.createElement("description");
		remLabel.setAttribute("value", noteLine);
		tooltipItem.appendChild(remLabel);
	}	
}	  	 				

function userMoveTodoToReminderList(eventTarget) {
	var movedTodo = getTodoForSelectedItem( );

	var newReminder = new ReminderFoxEvent( movedTodo.id, movedTodo.date, movedTodo.summary );			
	newReminder.notes = movedTodo.notes;
	newReminder.priority = movedTodo.priority;
	newReminder.messageID = movedTodo.messageID;
	newReminder.completedDate = movedTodo.completedDate;
	newReminder.allDayEvent = movedTodo.allDayEvent;	
	newReminder.alarm = movedTodo.alarm;		
	newReminder.alarmLastAcknowledge = movedTodo.alarmLastAcknowledge;		
	newReminder.recurrence =	REMINDER_RECURRENCE_ONETIME;
	
	removeTodo();

	// add reminder in sorted order...
	reminders = reminderFox_getReminderEvents();				
	var sortedIndex = reminderFox_getSortedIndexOfNewReminder( reminders, newReminder, false );
	reminderFox_insertIntoArray( reminders, newReminder, sortedIndex );

	createListItem(newReminder);  // update UI list
	refreshCalendar();

	modifiedReminders();	    	
}

function userMoveToTodoList(eventTarget) {
	var targetTodoListName =  eventTarget.getAttribute( "label" );
	var movedTodo = getTodoForSelectedItem( );
	
	if ( movedTodo.date != null ) { // could want to move to a reminder
		var tabList = document.getElementById("tabList");	
		var tablistItem = tabList.childNodes[0];	  // get first tab (reminders)
		var tabLabel = tablistItem.getAttribute("label");		
		
		if ( tabLabel == targetTodoListName) {
			userMoveTodoToReminderList(eventTarget);
			return;
		}
	}	
	// if moving to ToDo's, use special "ToDo's" id (as label could be another language)
	var tabList = document.getElementById("tabList");	
	var tablistItem = tabList.childNodes[1];	  // get second tab -- "ToDo's"
	var tabLabel = tablistItem.getAttribute("label");		
	if ( tabLabel == targetTodoListName) {
		targetTodoListName = "ToDo's";
	}	
		
	var todosArr =	reminderFox_getReminderTodos();
	var todos = todosArr[targetTodoListName];
	if ( todos == null ) {
		todos = new Array();
		todosArr[targetTodoListName] = todos;
	}	
	removeTodo();
	var sortedIndex = reminderFox_getSortedIndexOfNewTodo(todos, movedTodo );
	reminderFox_insertIntoArray( todos, movedTodo, sortedIndex );
	
  	modifiedReminders();
}

function activateTodoContext(event) {
	var tree = document.getElementById("todoTree");
	var treeContextMenu = document.getElementById("todo-treechildren-contextmenu");
	document.popupNode = tree;
	
	var selectedTreeItemIndex = document.getElementById("todoTree").currentIndex;
	var treeChildren = document.getElementById("todoTreechildren");
	if ( treeChildren == null || selectedTreeItemIndex == -1 || treeChildren.childNodes.length == 0 ) {
		return;
	}
	treeContextMenu.showPopup(tree, event.clientX, event.clientY, "bottomleft", "topleft");
	
	var currentTodo = getTodoForSelectedItem( );
	if ( currentTodo == null ) {
		return;
	}
	
	
	// show current lists...
	var moveToList = document.getElementById("treechildren-contextmenu-moveToList-popup");	
	while (moveToList.hasChildNodes()) {
		 moveToList.removeChild(moveToList.firstChild);
	}
	var tabList = document.getElementById("tabList");	
	var tab =	tabList.selectedItem;
	var tabIndex =	tabList.selectedIndex;

	var index = tab.id.indexOf( ':' );
	if ( tabIndex <= 1 || index == -1 ) {
		name = "ToDo's";
	}
	else {
		name = tab.id.substring( index +1 , tab.id.length );
	}
	
	var i = 0;
	if ( currentTodo.date == null ) {
		i = 1;   // if no date on the ToDo, don't allow to move to a reminder
	}
	for ( ; i < tabList.childNodes.length; i++ ) {  
		var tablistItem = tabList.childNodes[i];	
		var tabLabel = tablistItem.getAttribute("label");
		if ( tabLabel != name ) {
			var menuItem = document.createElement("menuitem");
			menuItem.setAttribute( "label", tabLabel );
			menuItem.setAttribute( "oncommand", "userMoveToTodoList(event.target)");
			moveToList.appendChild(menuItem);
		}
	}	
	
	// modify context menu depending on Important reminder status
	var contextMenuImportant = document.getElementById("treechildren-contextmenu-important2");	
	if ( currentTodo.priority != REMINDER_PRIORITY_IMPORTANT ) {
		contextMenuImportant.setAttribute("checked", "false");	
	}
	else {
		contextMenuImportant.setAttribute("checked", "true");	
	}	
	
	var contextMenuComplete = document.getElementById("treechildren-contextmenu-markAsComplete2");	
	if ( currentTodo.completedDate != null  ) {
			contextMenuComplete.setAttribute("checked", "true");	
	}
	else {
		contextMenuComplete.setAttribute("checked", "false");	
	}	


	var contextMenuShowInTooltip = document.getElementById("treechildren-contextmenu-showInTooltip");	
	if ( currentTodo.showInTooltip ) {
		contextMenuShowInTooltip.setAttribute("checked", "true");	
	}
	else {
		contextMenuShowInTooltip.setAttribute("checked", "false");	
	}

	// disable moveUp/moveDown if that option isn't available
	var moveUpMenu = document.getElementById("treechildren-contextmenu-moveUp");	
	if ( selectedTreeItemIndex == 0 ) {
		moveUpMenu.setAttribute( "disabled", true );
	}
	else {
		moveUpMenu.setAttribute( "disabled", false );
	}
	
	var moveDownMenu = document.getElementById("treechildren-contextmenu-moveDown");	
	if ( selectedTreeItemIndex == (treeChildren.childNodes.length - 1) ) {
		moveDownMenu.setAttribute( "disabled", true );
	}
	else {
		moveDownMenu.setAttribute( "disabled", false );
	}
	
	// If reminder is associated with an email, show the View Mail context menu item.  Otherwise, do not.
    var showMail = document.getElementById("treechildren-contextmenu-showMail2");	
    if ( showMail != null ) {
		if ( currentTodo.messageID == null  ) {
			showMail.setAttribute("hidden", "true");	
		}
		else {
			showMail.setAttribute("hidden", "false");	
		}
	}	
		
}


function processKeyPressedOnReminderTree(event) {
	if (event.keyCode == 46)   // delete key
		userDeleteReminder();
	else if (event.keyCode == 13) // return
		editReminder();
	else if (event.charCode == 32)	// space bar
		toggleMarkAsComplete();				
}

function processKeyPressedOnTodoTree(event) {
	if (event.keyCode == 46)   // delete key
		userDeleteTodo();
	else if (event.keyCode == 13)  // return
		editTodo();
	else if (event.charCode == 32)    // space bar
		toggleTodoMarkAsComplete();		
}



function editReminder() {
	var selectedTreeItemIndex = document.getElementById("reminderTree").currentIndex;
	var treeChildren = document.getElementById("treechildren");
	  
	if ( selectedTreeItemIndex == -1 ) {
		return;
	}
	
	var selectedTreeItem = treeChildren.childNodes[selectedTreeItemIndex];
	if (  selectedTreeItem == null ) {
		return;
	}

	var currentReminder = getReminderForSelectedItem();
	var originalReminder = reminderFox_cloneReminderFoxEvent(currentReminder);

	var newOptions = { reminder: currentReminder, editing:  true,  addReminder: false };
	window.openDialog("chrome://reminderfox/content/reminderOptionsDialog.xul",
			"window:reminderFoxReminderOptionsDialog", "chrome,resizable,modal", newOptions);

	if ( newOptions.addReminder ) {
		currentReminder = newOptions.reminder;
		if ( originalReminder.date.getFullYear() != currentReminder.date.getFullYear() ||
			originalReminder.date.getMonth() != currentReminder.date.getMonth() ||
			originalReminder.date.getDate() != currentReminder.date.getDate() ) {
				// if the date has changed, treat as a new reminder.  This is because 
				// We want to re-add in the proper sorted order into the list of reminders
				
				removeListItemsForReminder(originalReminder); 
				// remove from model list
				var reminders = reminderFox_getReminderEvents();	
				for( var i = 0; i < reminders.length; i++) {
					if ( reminders[i].id == originalReminder.id ) {
						reminderFox_removeElement(reminders, i);
						break;
					}
				}
	
				// add reminder in sorted order...
				reminders = reminderFox_getReminderEvents();					
				if ( currentReminder.remindUntilCompleted != REMINDERFOX_REMIND_UNTIL_COMPLETE_NONE ) {
	     			currentReminder.remindUntilCompleted = REMINDERFOX_REMIND_UNTIL_COMPLETE_TO_BE_MARKED;
	     		}				
				var sortedIndex = reminderFox_getSortedIndexOfNewReminder( reminders, currentReminder, false );
				reminderFox_insertIntoArray( reminders, currentReminder, sortedIndex );

				createListItem(currentReminder);			
			}
			// if the recurrence has changed, then we want to update the list as the dates may have 
			// changed
			else 	if ( originalReminder.recurrence != currentReminder.recurrence ) {
				removeListItemsForReminder(originalReminder);
				createListItem(currentReminder);			
			}
		
			var currentDate = oeDatePicker.gSelectedDate;
			if ( currentDate == null ) {
				currentDate = new Date();
			}	
			
			var newDate = new Date();
			if ( currentReminder.alarm != null ) {
				currentReminder.alarmLastAcknowledge = newDate.getTime();
			}
			currentReminder.lastModified = reminderFox_getDateAsString(newDate );
			var reminder = reminderFox_processReminderDescription(currentReminder,  currentDate.getFullYear());		
			var modified = updateReminderInList( reminder );

			refreshCalendar();
			modifiedReminders();
		}
}

function userDeleteReminder() {
	var selectedTreeItemIndex = document.getElementById("reminderTree").currentIndex;
	var treeChildren = document.getElementById("treechildren");
	if ( selectedTreeItemIndex < 0 || selectedTreeItemIndex >= treeChildren.childNodes.length ) {
		return;
	}
	var selectedTreeItem = treeChildren.childNodes[selectedTreeItemIndex];

	var dateLabel = selectedTreeItem.childNodes[0].childNodes[0].getAttribute("label");
	var descLabel = selectedTreeItem.childNodes[0].childNodes[1].getAttribute("label");
	
	var nsIPromptService = Components.interfaces.nsIPromptService;
	var nsPrompt_CONTRACTID = "@mozilla.org/embedcomp/prompt-service;1";
	var gPromptService = Components.classes[nsPrompt_CONTRACTID].getService(nsIPromptService);
	if (gPromptService.confirm(window,
		g_reminderFoxBundle.getString("rf.add.deleteReminder.title"),
		g_reminderFoxBundle.getString("rf.add.deleteReminder.description") + "\n  " + dateLabel + ": " + descLabel   )) {
     	removeReminder();
     	
		refreshCalendar();
		
		modifiedReminders();
     }
}

function userMoveReminderToTodo(eventTarget) {
	var selectedTreeItemIndex = document.getElementById("reminderTree").currentIndex;
	var treeChildren = document.getElementById("treechildren");
	var selectedTreeItem = treeChildren.childNodes[selectedTreeItemIndex];

	var currentReminder = getReminderForSelectedItem( );
	var newTodo = new ReminderFoxTodo( currentReminder.id, currentReminder.summary, currentReminder.date);			
	newTodo.notes = currentReminder.notes;
	newTodo.priority = currentReminder.priority;
	newTodo.messageID = currentReminder.messageID;
	newTodo.completedDate = currentReminder.completedDate;
	newTodo.allDayEvent = currentReminder.allDayEvent;	
	newTodo.alarm = currentReminder.alarm;		
	newTodo.alarmLastAcknowledge = currentReminder.alarmLastAcknowledge;		
	
	// remove from reminders
	removeReminder();
	
	
	var targetTodoListName =  eventTarget.getAttribute( "label" );

	// if moving to ToDo's, use special "ToDo's" id (as label could be another language)
	var tabList = document.getElementById("tabList");	
	var tablistItem = tabList.childNodes[1];	  // get second tab -- "ToDo's"
	var tabLabel = tablistItem.getAttribute("label");		
	if ( tabLabel == targetTodoListName) {
		targetTodoListName = "ToDo's";
	}
	
	var todosArr =	reminderFox_getReminderTodos();
	var todos = todosArr[targetTodoListName];
	if ( todos == null ) {
		todos = new Array();
		todosArr[targetTodoListName] = todos;
	}	

	var sortedIndex = reminderFox_getSortedIndexOfNewTodo(todos, newTodo );
	reminderFox_insertIntoArray( todos, newTodo, sortedIndex );    				
			
	// if todo list is selected (has child nodes, need to add a list item to it)
	reminderFoxTabDirtied = true;
	
	refreshCalendar();

	modifiedReminders();	    	    		

}

function userDeleteTodo() {
	var selectedTreeItemIndex = document.getElementById("todoTree").currentIndex;
	if ( selectedTreeItemIndex < 0  ) {
		return;
	}	
	var treeChildren = document.getElementById("todoTreechildren");
	var selectedTreeItem = treeChildren.childNodes[selectedTreeItemIndex];

	var descLabel = selectedTreeItem.childNodes[0].childNodes[0].getAttribute("label");
	
	var nsIPromptService = Components.interfaces.nsIPromptService;
	var nsPrompt_CONTRACTID = "@mozilla.org/embedcomp/prompt-service;1";
	var gPromptService = Components.classes[nsPrompt_CONTRACTID].getService(nsIPromptService);
	if (gPromptService.confirm(window,
			g_reminderFoxBundle.getString("rf.add.deleteToDo.title"),
			g_reminderFoxBundle.getString("rf.add.deleteToDo.description") + "\n  " + descLabel   )) {

     	removeTodo();
     	
  		modifiedReminders();
     }
}


function moveTodoUp() {
	var selectedTreeItemIndex = document.getElementById("todoTree").currentIndex;
	var currentTodo = getTodoForSelectedItem( );
	var todos = getCurrentTodoList();
	var i;
	var found = false;
	for (  i = 0; i < todos.length; i++ ) {
		if ( todos[i].id == currentTodo.id ) {
			found = true;
			break;
		}
	}
	
	if ( found && i > 0 ) { 
		var newIndex = i - 1;  // insert before old position
		
		var newTodo =	reminderFox_cloneReminderFoxTodo( currentTodo );
		removeTodo();
		
		reminderFox_insertIntoArray( todos, newTodo, newIndex );
	
		var newListIndex = selectedTreeItemIndex - 1;
		createTodoListItemAtIndex(newTodo,newListIndex );
		
		modifiedReminders();
	}
}



function moveTodoDown() {	var selectedTreeItemIndex = document.getElementById("todoTree").currentIndex;
	var currentTodo = getTodoForSelectedItem( );
	var todos = getCurrentTodoList();
	var i;
	var found = false;
	for (  i = 0; i < todos.length; i++ ) {
		if ( todos[i].id == currentTodo.id ) {
			found = true;
			break;
		}
	}
	
	if ( found ) { 
		var newIndex = i + 1;  // insert after old position
		
		var newTodo =	reminderFox_cloneReminderFoxTodo( currentTodo );
		removeTodo();
		
		reminderFox_insertIntoArray( todos, newTodo, newIndex );
	
		var newListIndex = selectedTreeItemIndex + 1;
		createTodoListItemAtIndex(newTodo,newListIndex );
		
		modifiedReminders();
	}
}


function toggleTodoImportantFlag() {
	var currentTodo = getTodoForSelectedItem( );
	if ( currentTodo.priority == REMINDER_PRIORITY_NORMAL) { 
		currentTodo.priority = REMINDER_PRIORITY_IMPORTANT;
	}
	else {
		currentTodo.priority = REMINDER_PRIORITY_NORMAL;
	}
	
	var modified = updateTodoInList( currentTodo );
	refreshCalendar();
}

function getReminderForSelectedItem() {
	var selectedTreeItemIndex = document.getElementById("reminderTree").currentIndex;
	if ( selectedTreeItemIndex != -1 ) {
		var treeChildren = document.getElementById("treechildren");
		var selectedTreeItem = treeChildren.childNodes[selectedTreeItemIndex];
		var reminderRefId = selectedTreeItem.childNodes[0].getAttribute(REMINDER_ID_REF);
		return reminderFox_getRemindersById( reminderRefId );
	}
	else {
		return null;
	}
}

function selectReminderById( reminderID) {
	var treeChildren = document.getElementById("treechildren");
	var treeitems = treeChildren.childNodes;
	for (var i=0; i < treeitems.length; i++) {
		var item = treeitems[i];		
		var row = item.childNodes[0];
		var reminderRefId = row.getAttribute(REMINDER_ID_REF);	
		if ( reminderRefId ==reminderID ) {
			document.getElementById("reminderTree").currentIndex = i;
			var treeSelection = document.getElementById("reminderTree").view.selection		
			treeSelection.select(i);
			
			// make sure that newly selected row is shown in scroll pane
			var value = document.getElementById("treeparent").value;
		  	var tree = document.getElementById("reminderTree");			
			var boxobject = tree.boxObject;
			boxobject.QueryInterface(Components.interfaces.nsITreeBoxObject);

			// make sure it shows up at the top if possible
			var first = boxobject.getFirstVisibleRow();
			var last = boxobject.getLastVisibleRow();
			if ( i < first || i > last ) {	
				boxobject.scrollToRow(treeitems.length - 1);
				boxobject.scrollToRow(treeitems.length - 9);
			}
								
			var previousReminderOffset = 3;
			if ( i < previousReminderOffset ) { 
				boxobject.ensureRowIsVisible(i);
			}
			else {
				boxobject.ensureRowIsVisible(i  - previousReminderOffset);
			}	
			break;
		}
	}
}


function selectTodoById( todoListName, reminderID) {
	var tabList = document.getElementById("tabList");	
	for ( var i = 1; i < tabList.childNodes.length; i++ ) {  // i =1, because we want to skip reminders
		var tablistItem = tabList.childNodes[i];	
		var tabLabel = tablistItem.getAttribute("label");
		if ( tabLabel == todoListName) {
			tabList.selectedItem = tablistItem;
			var treeChildren = document.getElementById("todoTreechildren");
			var treeitems = treeChildren.childNodes;
			for (var i=0; i < treeitems.length; i++) {
				var item = treeitems[i];		
				var row = item.childNodes[0];
				var reminderRefId = row.getAttribute(REMINDER_ID_REF);	
				if ( reminderRefId ==reminderID ) {
					document.getElementById("todoTree").currentIndex = i;
					var treeSelection = document.getElementById("todoTree").view.selection		
					treeSelection.select(i);
					
					// make sure that newly selected row is shown in scroll pane
					var value = document.getElementById("treeparent").value;
				  	var tree = document.getElementById("todoTree");			
					var boxobject = tree.boxObject;
					boxobject.QueryInterface(Components.interfaces.nsITreeBoxObject);
		
					// make sure it shows up at the top if possible
					var first = boxobject.getFirstVisibleRow();
					var last = boxobject.getLastVisibleRow();
					if ( i < first || i > last ) {	
						boxobject.scrollToRow(treeitems.length - 1);
						boxobject.scrollToRow(treeitems.length - 9);
					}
										
					var previousReminderOffset = 3;
					if ( i < previousReminderOffset ) { 
						boxobject.ensureRowIsVisible(i);
					}
					else {
						boxobject.ensureRowIsVisible(i  - previousReminderOffset);
					}	
					break;
				}
			}
			break;
			
		}
	}		
	
	

}


function getTodoForSelectedItem() {
	var selectedTreeItemIndex = document.getElementById("todoTree").currentIndex;
	if ( selectedTreeItemIndex != -1 ) {
		var treeChildren = document.getElementById("todoTreechildren");
		var selectedTreeItem = treeChildren.childNodes[selectedTreeItemIndex];
		var todoRefId = selectedTreeItem.childNodes[0].getAttribute(REMINDER_ID_REF);
		return reminderFox_getTodosById( todoRefId, 	getCurrentTodoList());
	}
	else {
		return null;
	}
}

function toggleImportantFlag() {
	var currentReminder = getReminderForSelectedItem( );
	if ( currentReminder.priority == REMINDER_PRIORITY_NORMAL) { 
		currentReminder.priority = REMINDER_PRIORITY_IMPORTANT;
	}
	else {
		currentReminder.priority = REMINDER_PRIORITY_NORMAL;
	}
	var modified = updateReminderInList( currentReminder );
	refreshCalendar();
}

function updateReminderInList( reminder) {
	var modified = true;
	var treeChildren = document.getElementById("treechildren");
	var todaysDate= new Date();
	var treeitems = treeChildren.childNodes;
	
	var year = oeDatePicker.gSelectedDate.getFullYear();
	if ( year == null ) {
		year = new Date().getFullYear();
	}
	var reminderInstanceDate;
	for (var i=0; i < treeitems.length; i++) {
		var item = treeitems[i];		
		var row = item.childNodes[0];
		var reminderRefId = row.getAttribute(REMINDER_ID_REF);	
		if ( reminderRefId == reminder.id ) {
			// check if reminder.complete and then reminder.date compared to today's date - first one
			// >= today, mark it as complete.  No others... 
			if ( reminder.completedDate != null  ) {   
				var dateLabel = item.childNodes[0].childNodes[0].getAttribute("label");
				var monthAndDate = reminderFox_decodeDateVariableString(dateVariableString, dateLabel );
				day = monthAndDate.date;
				monthAsInteger = monthAndDate.month;			
				reminderInstanceDate = new Date( year, monthAsInteger, day );
			}

			updateReminder(  reminder, item, reminderInstanceDate );
		}
	}
	reminder.lastModified = reminderFox_getDateAsString(todaysDate );

	if ( modified ) {
		modifiedReminders();	
	}
	return modified;
}

function getTreeItemForReminder( reminder ) {
	var treeChildren = document.getElementById("treechildren");
	var treeitems = treeChildren.childNodes;
	for (var i=treeitems.length - 1; i >= 0; i--) {
		var item = treeitems[i];
		var row = item.childNodes[0];
		var reminderRefId = row.getAttribute(REMINDER_ID_REF);	
		if ( reminderRefId == reminder.id ) {			
			return item;
		}
	}
	return null;
}

function updateReminder( reminder, selectedTreeItem, reminderInstanceDate) {
	var modified = true;

	if ( selectedTreeItem == null ) {
		selectedTreeItem = getTreeItemForReminder( reminder );
	}

	var dateNode = selectedTreeItem.childNodes[0].childNodes[0];
	var descriptionNode = selectedTreeItem.childNodes[0].childNodes[1];
    var timeNode = selectedTreeItem.childNodes[0].childNodes[2];			
    var completedDateNode = selectedTreeItem.childNodes[0].childNodes[3];			  
	var repeatNode = selectedTreeItem.childNodes[0].childNodes[4];		    
    var completeNode = selectedTreeItem.childNodes[0].childNodes[5];       	
    var remindUntilCompleteNode = selectedTreeItem.childNodes[0].childNodes[6];             		
    var notesNode = selectedTreeItem.childNodes[0].childNodes[7];             
    var mailNode = selectedTreeItem.childNodes[0].childNodes[8];                  
	
	// update description
	
	var year = oeDatePicker.gSelectedDate.getFullYear();
	if ( year == null ) {
		year = new Date().getFullYear();
	}

	reminder = reminderFox_processReminderDescription(reminder, year);
	descriptionNode.setAttribute( "label", reminder.summary );

	 // update importance
	 var isImportant = false;
	 if ( reminder.priority == REMINDER_PRIORITY_IMPORTANT) { 
             // mark the date and description as important (red-highlighted)
            dateNode.setAttribute("properties", "important");
            descriptionNode.setAttribute("properties", "important");
            timeNode.setAttribute("properties", "important");
            isImportant = true;
         }
       else {
            dateNode.removeAttribute("properties");
            descriptionNode.removeAttribute("properties");
			timeNode.removeAttribute("properties");            
       }
       

		if ( reminder.allDayEvent ) {
			timeNode.setAttribute("label", REMINDER_FOX_TIME_ALL_DAY_LABEL);
		}
		else {
			var time = reminderFox_getAddTimeString(reminder);
			if ( time == null ) {
				timeNode.setAttribute("label", REMINDER_FOX_TIME_ALL_DAY_LABEL);
			}
			else {
				timeNode.setAttribute("label", time);
			}
		}       
		
		// update once
		if ( reminder.recurrence  == REMINDER_RECURRENCE_YEARLY ) {
			repeatNode.setAttribute("label", REPEAT_LABEL_YEARLY);
		}
		else if ( reminder.recurrence  == REMINDER_RECURRENCE_YEARLY_DAY ) {
			repeatNode.setAttribute("label", REPEAT_LABEL_YEARLY_DAY);
		}		
		else 	if ( reminder.recurrence  == REMINDER_RECURRENCE_MONTHLY_DATE ) {
			repeatNode.setAttribute("label", REPEAT_LABEL_MONTHLY);
		}
		else if ( reminder.recurrence  == REMINDER_RECURRENCE_MONTHLY_DAY ) {
			repeatNode.setAttribute("label", REPEAT_LABEL_MONTHLY_DAY);
		}
		else	if ( reminder.recurrence  == REMINDER_RECURRENCE_WEEKLY ) {		
			repeatNode.setAttribute("label", REPEAT_LABEL_WEEKLY);
		}
		else	if ( reminder.recurrence  == REMINDER_RECURRENCE_WEEKLY_ALTERNATING ) {		
			repeatNode.setAttribute("label", REPEAT_LABEL_WEEKLY_ALTERNATING);
		}		
		else	if ( reminder.recurrence  == REMINDER_RECURRENCE_DAILY ) {		
			repeatNode.setAttribute("label", REPEAT_LABEL_DAILY);
		}			
		else {		
			repeatNode.setAttribute("label", REPEAT_LABEL_NONE);
		}		
			      
       // update complete
	  if ( reminderFox_isCompletedForDate( reminder, reminderInstanceDate ) )  {
        	   	completeNode.setAttribute("src",REMINDER_FOX_COMPLETED_IMAGE);	
       	 		 if ( isImportant ) {
	        	 	descriptionNode.setAttribute("properties", "imporantCompleteText");     	
	        	 }
	        	 else {
	        	 	descriptionNode.setAttribute("properties", "completeText");     	
	        	 } 	
	        	 
				if ( useDefaultDate ) {
					var monthAsText = reminderFox_getMonthAsText(reminder.completedDate.getMonth());		
					completedDateNode.setAttribute("label", monthAsText + " " + reminder.completedDate.getDate());
				}
				else {
					completedDateNode.setAttribute("label", reminderFox_getDateVariableString( reminder, reminder.completedDate ) );
				} 	        	 
	        	 
         }
 		else {
				completeNode.removeAttribute("src");
       	 		 if ( isImportant ) {
	        	 	//descriptionNode.setAttribute("properties", "imporantCompleteText");     	
	        	 }
	        	 else {
	        	 	descriptionNode.removeAttribute( "properties" );
	        	 } 					
       	 		completedDateNode.removeAttribute("label");
		}
		        
         // update remind until complete
         if ( reminder.remindUntilCompleted != REMINDERFOX_REMIND_UNTIL_COMPLETE_NONE ) {
	     	setRemindUntilCompleteColumn( reminder, remindUntilCompleteNode );        	 
         }
		else {
				remindUntilCompleteNode.removeAttribute("src");
		}       

	  	if ( reminder.notes != null ) {
	  	     //  notesNode.setAttribute("properties", "notes");
     		notesNode.setAttribute("src", REMINDER_FOX_NOTES_IMAGE);			
     	}              
		else {
				notesNode.removeAttribute("src");
				//notesNode.removeAttribute("properties");
		}        	
		
	  	if ( mailNode != null ) {
	  		if ( reminder.messageID != null ) {
     		   mailNode.setAttribute("src", REMINDER_FOX_MAIL_IMAGE);	
	  		}		        
			else {
				mailNode.removeAttribute("src");
			}
	  	}   				 		
}
  
  

  
  
  
function updateTodoInList( todo) {
	var modified = true;
	var treeChildren = document.getElementById("todoTreechildren");

	var selectedTreeItemIndex = document.getElementById("todoTree").currentIndex;
	var selectedTreeItem = treeChildren.childNodes[selectedTreeItemIndex];	
	
	var dateNode = selectedTreeItem.childNodes[0].childNodes[0];
	var descriptionNode = selectedTreeItem.childNodes[0].childNodes[1];
	var timeNode = selectedTreeItem.childNodes[0].childNodes[2];
    var completedDateNode = selectedTreeItem.childNodes[0].childNodes[3];   	
    var completeNode = selectedTreeItem.childNodes[0].childNodes[4];       	
    var showInTooltipNode = selectedTreeItem.childNodes[0].childNodes[5];    
    var notesNode = selectedTreeItem.childNodes[0].childNodes[6];       
    var mailNode = selectedTreeItem.childNodes[0].childNodes[7];                  
	
	if ( todo.date != null ) {
		var monthAsText = reminderFox_getMonthAsText(todo.date.getMonth());		
		if ( useDefaultDate ) {
			dateNode.setAttribute("label", monthAsText + " " + todo.date.getDate());
		}
		else {
			dateNode.setAttribute("label", reminderFox_getDateVariableString( todo, todo.date ) );
		}	
				
		if (  todo.allDayEvent ) {
			timeNode.setAttribute("label", REMINDER_FOX_TIME_ALL_DAY_LABEL);
		}
		else {
			var time = reminderFox_getAddTimeString(todo);
			if ( time == null ) {
				timeNode.setAttribute("label", REMINDER_FOX_TIME_ALL_DAY_LABEL);
			}
			else {			
				timeNode.setAttribute("label", time);
			}
		}			
	}
	else {
		dateNode.removeAttribute( "label" );
		timeNode.removeAttribute("label");
	}
	
	
	// update description
	 todo = reminderFox_processReminderDescription(todo,  new Date().getFullYear(), true );	
	descriptionNode.setAttribute( "label", todo.summary );
	
	 // update importance
	 var isImportant = false;
	 if ( todo.priority == REMINDER_PRIORITY_IMPORTANT) { 
         // mark the description as important (red-highlighted)
        descriptionNode.setAttribute("properties", "important");
        isImportant = true;
     }
     else {
        descriptionNode.removeAttribute("properties");
     }
     
   // update show in tooltip
   if ( todo.completedDate != null  ) {
    	completeNode.setAttribute("src",REMINDER_FOX_COMPLETED_TODO_IMAGE);	
    	
   	 	if ( isImportant ) {
        	 descriptionNode.setAttribute("properties", "imporantCompleteText");     	
    	 }
    	 else {
    	 	descriptionNode.setAttribute("properties", "completeText");     	
    	 } 	    
    	 
    	 
		if ( useDefaultDate ) {
			var monthAsText = reminderFox_getMonthAsText(todo.completedDate.getMonth());		
			completedDateNode.setAttribute("label", monthAsText + " " + todo.completedDate.getDate());
		}
		else {
			completedDateNode.setAttribute("label", reminderFox_getDateVariableString( todo, todo.completedDate ) );
		} 	     	 
    	 	
     }
 	else {
   	 	if ( isImportant ) {
        	 	//descriptionNode.setAttribute("properties", "imporantCompleteText");     	
        	 	             // mark the date and description as important (red-highlighted)
            //dateNode.setAttribute("properties", "important");
    	 }
    	 else {
    	 	descriptionNode.removeAttribute( "properties" );
    	 } 			 	
		completeNode.removeAttribute("src");
		completedDateNode.removeAttribute("label");
	}         
   
   // update show in tooltip   
   if ( todo.showInTooltip ) {
    	 showInTooltipNode.setAttribute("src", REMINDER_FOX_SHOW_IN_TOOLTIP_IMAGE);		 
     }
 	else {
		showInTooltipNode.removeAttribute("src");
	}    

   if ( todo.notes != null  ) {
    	 notesNode.setAttribute("src",REMINDER_FOX_NOTES_IMAGE);	
     }
 	else {
		notesNode.removeAttribute("src");
	}    	
		
  	if ( mailNode != null ) {
  		if ( todo.messageID != null ) {
 		   mailNode.setAttribute("src", REMINDER_FOX_MAIL_IMAGE);	
  		}		        
		else {
			mailNode.removeAttribute("src");
		}
  	}   		
		
	if ( modified ) {
		modifiedReminders();	
	}
	return modified;
		
}

function refreshCalendar() {
	calendarReminderArray = null;	
	oeDatePicker.redrawDays();
}


function toggleTodoShowInTooltip() {
	var currentTodo = getTodoForSelectedItem( );
	currentTodo.showInTooltip = !currentTodo.showInTooltip;
	var modified = updateTodoInList( currentTodo );
	modifiedReminders();
}

function toggleRemindUntilCompleted() {
	var currentReminder = getReminderForSelectedItem( );
	var cleanUpReminderInList = false;

	if ( currentReminder.remindUntilCompleted == REMINDERFOX_REMIND_UNTIL_COMPLETE_NONE ) {
		currentReminder.remindUntilCompleted = REMINDERFOX_REMIND_UNTIL_COMPLETE_TO_BE_MARKED;
	}
	else if ( currentReminder.remindUntilCompleted == REMINDERFOX_REMIND_UNTIL_COMPLETE_TO_BE_MARKED ) {
		currentReminder.remindUntilCompleted = REMINDERFOX_REMIND_UNTIL_COMPLETE_NONE;
	}
	else 	if ( currentReminder.remindUntilCompleted == REMINDERFOX_REMIND_UNTIL_COMPLETE_MARKED ) {
		currentReminder.remindUntilCompleted = REMINDERFOX_REMIND_UNTIL_COMPLETE_NONE;
		cleanUpReminderInList = true;
	}
		
	var modified = updateReminderInList( currentReminder );

	modifiedReminders();
	
	// if is was marked as RemindUntilCompleted and was showing in the list at a later date, we  need to remove this from the
	// UI list back to its original location
	if ( cleanUpReminderInList ) {
		removeListItemsForReminder(currentReminder);
		createListItem(currentReminder	);
	}
	
	refreshCalendar();
}


function toggleMarkAsComplete() {
	var currentReminder = getReminderForSelectedItem( );
	if ( currentReminder != null ) {
		var treeChildren = document.getElementById("treechildren");
		var selectedTreeItemIndex = document.getElementById("reminderTree").currentIndex;
		var selectedTreeItem = treeChildren.childNodes[selectedTreeItemIndex];
		var year = oeDatePicker.gSelectedDate.getFullYear();
		if ( year == null ) {
			year = new Date().getFullYear();
		}		
		var dateLabel = selectedTreeItem.childNodes[0].childNodes[0].getAttribute("label");
		var monthAndDate = reminderFox_decodeDateVariableString(dateVariableString, dateLabel );
		day = monthAndDate.date;
		monthAsInteger = monthAndDate.month;				
		reminderInstanceDate = new Date( year, monthAsInteger, day );	
				
		if ( reminderFox_isCompletedForDate( currentReminder, reminderInstanceDate ) )  {
				currentReminder.completedDate = null;
		}
		else {
			currentReminder.completedDate = reminderInstanceDate;		

			if ( currentReminder.remindUntilCompleted == REMINDERFOX_REMIND_UNTIL_COMPLETE_TO_BE_MARKED ||
				  currentReminder.remindUntilCompleted == REMINDERFOX_REMIND_UNTIL_COMPLETE_MARKED ) {
	     		toggleRemindUntilCompleted();
	     		return;  	
			}			
		}					

		var modified = updateReminderInList( currentReminder );
	
		modifiedReminders();
	}
}

function toggleTodoMarkAsComplete() {
	var currentTodo = getTodoForSelectedItem( );
	if ( currentTodo != null ) {
		if ( currentTodo.completedDate != null ) { 
			currentTodo.completedDate = null;
		}
		else {
			currentTodo.completedDate = new Date();;
		}
		var modified = updateTodoInList( currentTodo );
	
		modifiedReminders();
	}
}

function revertActions() {

	// I don't know how to refresh Reminders and Todos
	var revertReminders = true;
	var revertTodos = true;

	reminderFox_clearRemindersAndTodos();
	removeAllListItems(revertReminders, revertTodos);
	fillList(revertReminders, revertTodos);
	refreshCalendar();

	// grey out the rever buttons
	var revertButton= document.getElementById("revertbutton");
	revertButton.setAttribute( "disabled", true );
	
	var revertButtonTodos= document.getElementById("revertbuttonTodos");
	revertButtonTodos.setAttribute( "disabled", true );
	
	g_modified = false;
}


